--Fix:7区-天空之墙 神慧
local rules = {
	buyout = 100,
	bid = 0,

	buyout2 = 100,
	bid2 = 0,

	max = 10000,
	min = 5000,	
	tip = true,
	each = false,
	scroll = false,
}

local AHHelper = CreateFrame("frame")
local _G = getfenv(0)

local EACHPRICE_TITLE = "显示单价"
local EACHPRICE_TOOLTIP = "勾选此框可显示所有物品单价."
local BIDDEN_TEXT = "拍"
local REMOVE_TEXT = "取"
local QUERY_TEXT = "扫描"
local AUTOREMOVE_TEXT = "自动取消"
local REMOVEALL_TEXT = "全部取消"
local CLEARMEMORY_TEXT = "清空记录"
local AUTOAUCTION_TEXT = "自动拍卖"
local AUTO_CANCELAUCTION_CONFIRMATION = "是否要自动取消所有非最低价的拍卖物品？"
local CANCEL_ALLAUCTION_CONFIRMATION = "是否要取消所有拍卖物品？"
local CLEAR_MEMORY_CONFIRMATION = "是否要清空记录？"
local AUTO_AUCTION_CONFIRMATION = "请选择要自动拍卖的物品："
local AUTO_AUCTIONALL_CONFIRMATION = "即将拍卖所有扫描到的物品，是否要继续？"
local QUERYING_TEXT = "扫描中，正在估算剩余时间..."
local QUERYING_TEXT0 = "扫描中，预计剩余时间小于 10 秒..."
local QUERYING_TEXT1 = "扫描中，预计剩余时间还有 %d 秒..."
local QUERYING_TEXT2 = "扫描中，预计剩余时间还有 %d 分钟..."
local AUCTIONING_TEXT = "拍卖中，请稍候......"
local COMPLETEDQUERY_TEXT = "扫描已完成，总共扫描了 %d 个物品。"
local EACHPRICE_TEXT = "当前单价"
local NOTLOWEST_TEXT = "你的价格不是最低。"
local NOAUCTION_TEXT = "你没有拍卖该物品。"
local AUCTIONED_TEXT = "你已拍卖了该物品。"
local SPLITE_TEXT_LEFT = "分拆"
local SPLITE_TEXT_RIGHT = "个"

local GLYPH, ELEMENTAL, CLOTH, LEATHER, MINING, HERB, ENCHANTING, GEM, MEDICINE, QUEST, ALL
local PLAYER_NAME, ORG_ALPHA
local can_removeall, can_autoremove, checked_can_autoremove, checked_can_removeall
local bidding, removing, autoremoving, removingall, auto_bidding, auto_auctioning, querying

local browseFrames = {
	"AuctionFrame",
	"AuctionFrameTab1",
	"AuctionFrameTab2",
	"AuctionFrameTab3",
	"AuctionFrameMoneyFrame",
	"AuctionFrameCloseButton",
	"AuctionFrameBrowse",
	"AuctionFilterButton1",
	"AuctionFilterButton2",
	"AuctionFilterButton3",
	"AuctionFilterButton4",
	"AuctionFilterButton5",
	"AuctionFilterButton6",
	"AuctionFilterButton7",
	"AuctionFilterButton8",
	"AuctionFilterButton9",
	"AuctionFilterButton10",
	"AuctionFilterButton11",
	"AuctionFilterButton12",
	"AuctionFilterButton13",
	"AuctionFilterButton14",
	"AuctionFilterButton15",
	"BrowseFilterScrollFrame",
	"BrowseScrollFrame",
	"BrowseQualitySort",
	"BrowseLevelSort",
	"BrowseDurationSort",
	"BrowseHighBidderSort",
	"BrowseCurrentBidSort",
	"BrowseButton1",
	"BrowseButton2",
	"BrowseButton3",
	"BrowseButton4",
	"BrowseButton5",
	"BrowseButton6",
	"BrowseButton7",
	"BrowseButton8",
	"BrowsePrevPageButton",
	"BrowseNextPageButton",
	"IsUsableCheckButton",
	"BrowseName",
	"BrowseMinLevel",
	"BrowseMaxLevel",
	"BrowseDropDown",
	"BrowseBidPrice",
	"BrowseCloseButton",
	"BrowseBuyoutButton",
	"BrowseBidButton",
	"BrowseSearchButton",
	"BrowseResetButton",
	"ShowOnPlayerCheckButton",
}

local auctionsFrames = {
	"AuctionFrame",
	"AuctionFrameTab1",
	"AuctionFrameTab2",
	"AuctionFrameTab3",
	"AuctionFrameMoneyFrame",
	"AuctionFrameCloseButton",
	"AuctionFrameAuctions",
	"AuctionsQualitySort",
	"AuctionsDurationSort",
	"AuctionsHighBidderSort",
	"AuctionsBidSort",
	"AuctionsScrollFrame",
	"AuctionsButton1",
	"AuctionsButton2",
	"AuctionsButton3",
	"AuctionsButton4",
	"AuctionsButton5",
	"AuctionsButton6",
	"AuctionsButton7",
	"AuctionsButton8",
	"AuctionsButton9",
	"AuctionsItemButton",
	"StartPrice",
	"AuctionsShortAuctionButton",
	"AuctionsMediumAuctionButton",
	"AuctionsLongAuctionButton",
	"BuyoutPrice",
	"AuctionsDepositMoneyFrame",
	"AuctionsCloseButton",
	"AuctionsCancelAuctionButton",
	"AuctionsCreateAuctionButton",
}

AHHelper.hooks = {}
AHHelper.methods = {"SetHyperlink", "SetBagItem", "SetInventoryItem", "SetAuctionItem", "SetAuctionSellItem", "SetLootItem", "SetLootRollItem", "SetTradeSkillItem", "SetTrainerService", "SetInboxItem", "SetSendMailItem", "SetQuestItem", "SetQuestLogItem", "SetTradePlayerItem", "SetTradeTargetItem", "SetMerchantItem", "SetBuybackItem", "SetSocketGem", "SetExistingSocketGem", "SetHyperlinkCompareItem", "SetGuildBankItem", "SetMerchantCostItem"}

local itembutton = {}
local t1, t2 = {}, {}
local t3 = {[0] = {}, [1] = {}, [2] = {}, [3] = {}, [4] = {}}
local t4 = {id = {}, info = {}}
local t5 = {id = {}, info = {}}
local sparkTimer, sparkInterval = {0, 0, 0, 0, 0}, .2
local START_TIME, END_TIME, ALL_TIME, AVERAGE_TIME = 0, 0, 0, 0

-- base class
local pool = {
	__eq = function(a1, a2)
		if (not a1) or (not a2) then
			return false
		else
			for k, v in pairs(a1) do
				if a2[k] and (a1[k] ~= a2[k]) then
					return false
				end
			end
		end
		return true
	end,
	__le = function(a1, a2)
		if (not a1) or (not a2) then
			return false
		else
			for k, v in pairs(a1) do
				if ("number"==type(a2[k]) and "number"==type(a1[k])) and (a1[k] > a2[k]) then
					--print(format("t2[...].%s %d", k, a1[k]))
					--print(format("t1[...].%s %d", k, a2[k]))
					return false
				end
			end
		end
		return true
	end,
	__tostring = function(self)
		local s = "{ "
		local sep = ""
		for k, v in pairs(self) do
			if "number"==type(v) or "string"==type(v) then
				s = s .. sep .. k .. " = " ..  v
				sep = ", "
			elseif "table"==type(v) then
				s = s .. "[" .. k .. "]" .. sep
				sep = ", "
			end
		end
		return s .. " }"
	end,
	new = function(self, a)
		a = a or {}
		setmetatable(a, self)
		self.__index = self
		return a
	end,
	__mode = 'k',
}

local function copy(parent)
	local a = {}
	if parent then
		for k, v in pairs(parent) do
			a[k] = v
		end
		setmetatable(a, getmetatable(parent))
	end
	return a
end

local function maxn(a)
	local value = 0
	if "table"==type(a) then
		for _, v in pairs(a) do
			if "table"==type(v) then
				value = value + maxn(v)
			else
				value = value + 1
			end
		end
	end
	return value
end

local function getMaxLevel(frames)
	if "table" ~= type(frames) then return 0 end
	local level = 0
	if "table" == type(frames) then
		for _, v in pairs(frames) do
			if _G[v] and _G[v]:GetFrameLevel() > level then--11
				level = _G[v]:GetFrameLevel()
			end
		end
	end
	return level
end

local function setTip(self, ...)
	AHHelper:UpdateTooltip(self, ...)
	self:Show()
end

local function hook(tip, method)
	if not tip or not method then return end
	hooksecurefunc(tip, method, setTip)
end
tinsert(AHHelper.hooks, hook)

local function _compare(A, ...)
	if not A or 0 == #A then return nil end
	for i = 1, select("#", ...) do
		if A[i] ~= select(i, ...) then
			return false
		end
	end
	return true
end

local function _sort(A)
	if #A.id < 2 then return end
	for i = 1, #A.id-1 do
		for j = i+1, #A.id do
			if A.id[i] > A.id[j] then
				A.id[i], A.id[j] = A.id[j], A.id[i]
				A.info[i], A.info[j] = A.info[j], A.info[i]
			end
		end
	end
end

local icons = "|TInterface\\MoneyFrame\\UI-%sIcon:0|t"
local GOLD_TEXT = format(icons, "Gold")
local SILVER_TEXT = format(icons, "Silver")
local COPPER_TEXT = format(icons, "Copper")

local function MoneyToGSC(money)
	local gold = floor(money / (COPPER_PER_SILVER * SILVER_PER_GOLD))
	local silver = floor((money - (gold * COPPER_PER_SILVER * SILVER_PER_GOLD)) / COPPER_PER_SILVER)
	local copper = money % COPPER_PER_SILVER

	return gold, silver, copper
end

local function GSCToString(gold, silver, copper)
	local str, text
	if gold > 0 then
		str = format("|cffffffff%d|r%s", gold, GOLD_TEXT)
		text = text and text .. str or str
	end
	if silver > 0 then
		str = format(" |cffffffff%d|r%s", silver, SILVER_TEXT)
		text = text and text .. str or str
	end
	if copper > 0 then
		str = format(" |cffffffff%d|r%s", copper, COPPER_TEXT)
		text = text and text .. str or str
	end
	return text
end

local function GetFitSlot(item)
	local itemFamily = GetItemFamily(item)
	if select(9, GetItemInfo(item)) == "INVTYPE_BAG" then
	  itemFamily = 0
	end
	for bag = 0, 4 do
		local bagFamily = select(2, GetContainerNumFreeSlots(bag))
		if ( bagFamily == 0 or bit.band(itemFamily, bagFamily) > 0 ) and GetContainerNumFreeSlots(bag) > 0 then
			return bag, unpack(GetContainerFreeSlots(bag))
		end
	end
end

local function CreatButton(id, parent, text, w, h, ap, frame, rp, x, y)
	local button = CreateFrame("button", id, parent, "UIPanelButtonTemplate")
	button:SetWidth(w)
	button:SetHeight(h)
	button:SetPoint(ap, frame, rp, x, y)
	button:SetText(text)
	return button
end

local function AuctionSellItemButtonOnEvent(self, event, ...)
	if ( event == "NEW_AUCTION_UPDATE") then
		local name, texture, count, quality, canUse, price = GetAuctionSellItemInfo()
		AuctionsItemButton:SetNormalTexture(texture)
		AuctionsItemButtonName:SetText(name)
		if ( count > 1 ) then
			AuctionsItemButtonCount:SetText(count)
			AuctionsItemButtonCount:Show()
		else
			AuctionsItemButtonCount:Hide()
		end
		MoneyInputFrame_SetCopper(StartPrice, max(100, floor(price * 1.5)))
		MoneyInputFrame_SetCopper(BuyoutPrice, 0)
		if ( name ) then
			LAST_ITEM_AUCTIONED = name
			LAST_ITEM_COUNT = count
			LAST_ITEM_TEXTURE = texture
			LAST_ITEM_START_BID = MoneyInputFrame_GetCopper(StartPrice)
			LAST_ITEM_BUYOUT = MoneyInputFrame_GetCopper(BuyoutPrice)
		end
		UpdateDeposit()
	end
end

local function BrowseButtonOnClick(button)
	if bidding then return end
	local offset = FauxScrollFrame_GetOffset(BrowseScrollFrame)
	if not button then
		button = this
	end
	CloseAuctionStaticPopups()

	if #t4.id > 0 then
		for j = #t4.id, 1, -1 do
			local a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12 = GetAuctionItemInfo("list", offset + button:GetID())
			if 1 == #t4.id then
				if _compare(t4.info[j], a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12) and offset + button:GetID() == t4.id[j] then
					t4.id = {}
					t4.info = {}
					SetSelectedAuctionItem("list", 0)
					AuctionFrameBrowse_Update()
					AHHelper:UpdateBidButton()
					return
				end
			else
				if _compare(t4.info[j], a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12) and offset + button:GetID() == t4.id[j]then
					local lastprice
					tremove(t4.id, j)
					tremove(t4.info, j)
					AuctionFrameBrowse_Update()
					AHHelper:UpdateBidButton()
					SetSelectedAuctionItem("list", t4.id[#t4.id])
					if 0 == t4.info[#t4.id][10] then
						lastprice = t4.info[#t4.id][7]
					else
						lastprice = t4.info[#t4.id][10] + t4.info[#t4.id][8]
					end
					MoneyInputFrame_SetCopper(BrowseBidPrice, lastprice)
					return
				end
			end
		end
		local name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner = GetAuctionItemInfo("list", button:GetID() + offset)
		tinsert(t4.id, offset + button:GetID())
		tinsert(t4.info, {name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner})
		SetSelectedAuctionItem("list", t4.id[#t4.id])
		AuctionFrameBrowse_Update()
		AHHelper:UpdateBidButton()
	else
		local name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner = GetAuctionItemInfo("list", button:GetID() + offset)
		t4.id[1] = offset + button:GetID()
		t4.info[1] = {name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner}
		SetSelectedAuctionItem("list", t4.id[1])
		AuctionFrameBrowse_Update()
		AHHelper:UpdateBidButton()
	end
end

local function AuctionsButtonOnClick(button)
	if removing or removingall or autoremoving then return end
	local offset = FauxScrollFrame_GetOffset(AuctionsScrollFrame)
	if not button then
		button = this
	end
	CloseAuctionStaticPopups()

	if #t5.id > 0 then
		for j = #t5.id, 1, -1 do
			local a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13 = GetAuctionItemInfo("owner", offset + button:GetID())
			if 1 == #t5.id then
				if _compare(t5.info[j], a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) and offset + button:GetID() == t5.id[j] then
					t5.id = {}
					t5.info = {}
					SetSelectedAuctionItem("owner", 0)
					AuctionFrameAuctions_Update()
					AHHelper:UpdateCancelAuctionButton()
					return
				end
			else
				if _compare(t5.info[j], a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) and offset + button:GetID() == t5.id[j] then
					tremove(t5.id, j)
					tremove(t5.info, j)
					AuctionFrameAuctions_Update()
					AHHelper:UpdateCancelAuctionButton()
					SetSelectedAuctionItem("owner", t5.id[#t5.id])
					return
				end
			end
		end
		local name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner, saleStatus = GetAuctionItemInfo("owner", button:GetID() + offset)
		tinsert(t5.id, offset + button:GetID())
		tinsert(t5.info, {name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner, saleStatus})
		SetSelectedAuctionItem("owner", t5.id[#t5.id])
		AuctionFrameAuctions_Update()
		AHHelper:UpdateCancelAuctionButton()
	else
		local name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner, saleStatus = GetAuctionItemInfo("owner", button:GetID() + offset)
		t5.id[1] = offset + button:GetID()
		t5.info[1] = {name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner, saleStatus}
		SetSelectedAuctionItem("owner", t5.id[1])
		AuctionFrameAuctions_Update()
		AHHelper:UpdateCancelAuctionButton()
	end
end

local function AutoSetCopper()
	local name, texture, count, quality, canUse, price = GetAuctionSellItemInfo()
	local set = MoneyInputFrame_SetCopper
	if GetAuctionSellItemInfo() then
		if rules.each then
			if t1[name] and t1[name][texture] then
				local t1_bid = t1[name][texture].bid
				local t1_buyout = t1[name][texture].buyout
				if t1[name][texture].owner == PLAYER_NAME then
					set(StartPrice, ceil(t1_bid * count))
					set(BuyoutPrice, ceil(t1_buyout * count))
				else
					if ( t1_buyout - t1_bid >= rules.max ) or ( t1_buyout - t1_bid < rules.min ) then
						if t1_buyout ~= floor( (t1_buyout - rules.bid2*10000)/10000 )*10000 then
							if ( t1_buyout - rules.buyout2 > 0 ) and ( floor( (t1_buyout - rules.bid2*10000)/10000 ) >= 1 ) then
								if t1_buyout - rules.buyout2 > floor( (t1_buyout - rules.bid2*10000)/10000 )*10000 then
									set(StartPrice, floor( (t1_buyout - rules.bid2*10000)/10000 )*10000*count)
									set(BuyoutPrice, (t1_buyout - rules.buyout2)*count)
								elseif t1_buyout - 1 > floor( (t1_buyout - rules.bid2*10000)/10000 )*10000 then
									set(StartPrice, floor( (t1_buyout - rules.bid2*10000)/10000 )*10000*count)
									set(BuyoutPrice, (t1_buyout - 1)*count)
								else
									set(StartPrice, (floor( (t1_buyout - rules.bid2*10000)/10000 )*10000 - 1)*count)
									set(BuyoutPrice, t1_buyout*count)
								end
							elseif ( t1_buyout - rules.buyout2 <= 0 ) and ( floor( (t1_buyout - rules.bid2*10000)/10000 ) > 1 ) then
								if t1_buyout - 1 > floor( (t1_buyout - rules.bid2*10000)/10000 )*10000 then
									set(StartPrice, floor( (t1_buyout - rules.bid2*10000)/10000 )*10000*count)
									set(BuyoutPrice, (t1_buyout - 1)*count)
								else
									set(StartPrice, (floor( (t1_buyout - rules.bid2*10000)/10000 )*10000 - 1)*count)
									set(BuyoutPrice, t1_buyout*count)
								end
							elseif ( t1_buyout - rules.buyout2 > 0 ) and ( floor( (t1_buyout - rules.bid2*10000)/10000 ) < 1 ) then
								if t1_buyout - 1 > t1_bid then
									set(StartPrice, t1_bid*count)
									set(BuyoutPrice, (t1_buyout - 1)*count)
								else
									set(StartPrice, (t1_bid - 1)*count)
									set(BuyoutPrice, t1_buyout*count)
								end
							else
								if t1_buyout - 1 > t1_bid then
									set(StartPrice, t1_bid*count)
									set(BuyoutPrice, (t1_buyout - 1)*count)
								elseif t1_bid - 1 > 0 then
									set(StartPrice, (t1_bid - 1)*count)
									set(BuyoutPrice, t1_buyout*count)
								else
									set(StartPrice, t1_bid*count)
									set(BuyoutPrice, t1_buyout*count)
								end
							end
						else
							if ( t1_buyout - rules.buyout2 > 0 ) and ( t1_buyout - 10000 > 0 ) then
								if t1_buyout - rules.buyout2 > t1_buyout - 10000 then
									set(StartPrice, (t1_buyout - 10000)*count)
									set(BuyoutPrice, (t1_buyout - rules.buyout2)*count)
								elseif t1_buyout - 1 > t1_bid then
									set(StartPrice, t1_bid*count)
									set(BuyoutPrice, (t1_buyout - 1)*count)
								elseif t1_bid - 1 > 0 then
									set(StartPrice, (t1_bid - 1)*count)
									set(BuyoutPrice, t1_buyout*count)
								else
									set(StartPrice, t1_bid*count)
									set(BuyoutPrice, t1_buyout*count)
								end
							elseif ( t1_buyout - rules.buyout2 <= 0 ) and ( t1_buyout - 10000 > 0 ) then
								set(StartPrice, (t1_buyout - 10000)*count)
								set(BuyoutPrice, (t1_buyout - 1)*count)
							elseif ( t1_buyout - rules.buyout2 > 0 ) and ( t1_buyout - 10000 <= 0 ) then
								if t1_buyout - rules.buyout2 > t1_bid then
									set(StartPrice, t1_bid*count)
									set(BuyoutPrice, (t1_buyout - rules.buyout2)*count)
								elseif t1_buyout - 1 > t1_bid then
									set(StartPrice, t1_bid*count)
									set(BuyoutPrice, (t1_buyout - 1)*count)
								elseif t1_bid - 1 > 0 then
									set(StartPrice, (t1_bid - 1)*count)
									set(BuyoutPrice, t1_buyout*count)
								else
									set(StartPrice, t1_bid*count)
									set(BuyoutPrice, t1_buyout*count)
								end
							else
								if t1_buyout - 1 > t1_bid then
									set(StartPrice, t1_bid*count)
									set(BuyoutPrice, (t1_buyout - 1)*count)
								elseif t1_bid - 1 > 0 then
									set(StartPrice, (t1_bid - 1)*count)
									set(BuyoutPrice, t1_buyout*count)
								else
									set(StartPrice, t1_bid*count)
									set(BuyoutPrice, t1_buyout*count)
								end
							end
						end
					else
						if t1_buyout - rules.buyout > 0 and t1_bid - rules.bid > 0 then
							if ( t1_buyout - rules.buyout >= t1_bid - rules.bid + rules.buyout ) then
								set(StartPrice, (t1_bid - rules.bid)*count)
								set(BuyoutPrice, (t1_buyout - rules.buyout)*count)
							else
								if ( t1_buyout - 1 >= t1_bid - rules.bid ) then
									set(StartPrice, (t1_bid - rules.bid)*count)
									set(BuyoutPrice, (t1_buyout - 1)*count)
								else
									if ( t1_bid - rules.bid - rules.buyout > 0 ) then
										set(StartPrice, (t1_bid - rules.bid - rules.buyout)*count)
										set(BuyoutPrice, t1_buyout*count)
									else
										if ( t1_bid - rules.bid > 0 ) then
											set(StartPrice, (t1_bid - rules.bid )*count)
											set(BuyoutPrice, t1_buyout*count)
										else
											if ( t1_bid - 1 > 0 ) then
												set(StartPrice, (t1_bid - 1)*count)
												set(BuyoutPrice, t1_buyout*count)
											else
												set(StartPrice, t1_bid*count)
												set(BuyoutPrice, t1_buyout*count)
											end
										end
									end
								end
							end
						elseif t1_buyout - rules.buyout <= 0 and t1_bid - rules.bid > 0 then
							if ( t1_buyout - 1 >= t1_bid - rules.bid ) then
								set(StartPrice, (t1_bid - rules.bid)*count)
								set(BuyoutPrice, (t1_buyout - 1)*count)
							else
								if ( t1_bid - rules.bid - rules.buyout > 0 ) then
									set(StartPrice, (t1_bid - rules.bid - rules.buyout)*count)
									set(BuyoutPrice, t1_buyout*count)
								else
									if ( t1_bid - rules.bid > 0 ) then
										set(StartPrice, (t1_bid - rules.bid )*count)
										set(BuyoutPrice, t1_buyout*count)
									else
										if ( t1_bid - 1 > 0 ) then
											set(StartPrice, (t1_bid - 1)*count)
											set(BuyoutPrice, t1_buyout*count)
										else
											set(StartPrice, t1_bid*count)
											set(BuyoutPrice, t1_buyout*count)
										end
									end
								end
							end
						elseif t1_buyout - rules.buyout > 0 and t1_bid - rules.bid <= 0 then
							if t1_buyout - rules.buyout >= t1_bid then
								set(StartPrice, t1_bid*count)
								set(BuyoutPrice, (t1_buyout - rules.buyout)*count)
							else
								if t1_buyout - 1 >= t1_bid then
									set(StartPrice, t1_bid*count)
									set(BuyoutPrice, (t1_buyout - 1)*count)
								else
									if t1_bid - 1 > 0 then
										set(StartPrice, (t1_bid - 1)*count)
										set(BuyoutPrice, t1_buyout*count)
									else
										set(StartPrice, t1_bid*count)
										set(BuyoutPrice, t1_buyout*count)
									end
								end
							end
						else
							if t1_buyout - 1 >= t1_bid then
								set(StartPrice, t1_bid*count)
								set(BuyoutPrice, (t1_buyout - 1)*count)
							elseif t1_bid - 1 > 0 then
								set(StartPrice, (t1_bid - 1)*count)
								set(BuyoutPrice, t1_buyout*count)
							else
								set(StartPrice, t1_bid*count)
								set(BuyoutPrice, t1_buyout*count)
							end
						end
					end
				end
			end
		else
			if t1[name] and t1[name][texture] then
				local t1_bid = t1[name][texture].bid
				local t1_buyout = t1[name][texture].buyout
				if t1[name][texture].owner == PLAYER_NAME then
					set(StartPrice, (t1_bid * count))
					set(BuyoutPrice, (t1_buyout * count))
				else
					if ( (t1_buyout * count) - (t1_bid * count) >= rules.max ) or ( (t1_buyout * count) - (t1_bid * count) < rules.min ) then
						if (t1_buyout * count) ~= floor( ((t1_buyout * count) - rules.bid2*10000)/10000 )*10000 then
							if ( (t1_buyout * count) - rules.buyout2 > 0 ) and ( floor( ((t1_buyout * count) - rules.bid2*10000)/10000 ) >= 1 ) then
								if (t1_buyout * count) - rules.buyout2 > floor( ((t1_buyout * count) - rules.bid2*10000)/10000 )*10000 then
									set(StartPrice, floor( ((t1_buyout * count) - rules.bid2*10000)/10000 )*10000)
									set(BuyoutPrice, ((t1_buyout * count) - rules.buyout2))
								elseif (t1_buyout * count) - 1 > floor( ((t1_buyout * count) - rules.bid2*10000)/10000 )*10000 then
									set(StartPrice, floor( ((t1_buyout * count) - rules.bid2*10000)/10000 )*10000)
									set(BuyoutPrice, ((t1_buyout * count) - 1))
								else
									set(StartPrice, (floor( ((t1_buyout * count) - rules.bid2*10000)/10000 )*10000 - 1))
									set(BuyoutPrice, (t1_buyout * count))
								end
							elseif ( (t1_buyout * count) - rules.buyout2 <= 0 ) and ( floor( ((t1_buyout * count) - rules.bid2*10000)/10000 ) > 1 ) then
								if (t1_buyout * count) - 1 > floor( ((t1_buyout * count) - rules.bid2*10000)/10000 )*10000 then
									set(StartPrice, floor( ((t1_buyout * count) - rules.bid2*10000)/10000 )*10000)
									set(BuyoutPrice, ((t1_buyout * count) - 1))
								else
									set(StartPrice, (floor( ((t1_buyout * count) - rules.bid2*10000)/10000 )*10000 - 1))
									set(BuyoutPrice, (t1_buyout * count))
								end
							elseif ( (t1_buyout * count) - rules.buyout2 > 0 ) and ( floor( ((t1_buyout * count) - rules.bid2*10000)/10000 ) < 1 ) then
								if (t1_buyout * count) - 1 > (t1_bid * count) then
									set(StartPrice, (t1_bid * count))
									set(BuyoutPrice, ((t1_buyout * count) - 1))
								else
									set(StartPrice, ((t1_bid * count) - 1))
									set(BuyoutPrice, (t1_buyout * count))
								end
							else
								if (t1_buyout * count) - 1 > (t1_bid * count) then
									set(StartPrice, (t1_bid * count))
									set(BuyoutPrice, ((t1_buyout * count) - 1))
								elseif (t1_bid * count) - 1 > 0 then
									set(StartPrice, ((t1_bid * count) - 1))
									set(BuyoutPrice, (t1_buyout * count))
								else
									set(StartPrice, (t1_bid * count))
									set(BuyoutPrice, (t1_buyout * count))
								end
							end
						else
							if ( (t1_buyout * count) - rules.buyout2 > 0 ) and ( (t1_buyout * count) - 10000 > 0 ) then
								if (t1_buyout * count) - rules.buyout2 > (t1_buyout * count) - 10000 then
									set(StartPrice, ((t1_buyout * count) - 10000))
									set(BuyoutPrice, ((t1_buyout * count) - rules.buyout2))
								elseif (t1_buyout * count) - 1 > (t1_bid * count) then
									set(StartPrice, (t1_bid * count))
									set(BuyoutPrice, ((t1_buyout * count) - 1))
								elseif (t1_bid * count) - 1 > 0 then
									set(StartPrice, ((t1_bid * count) - 1))
									set(BuyoutPrice, (t1_buyout * count))
								else
									set(StartPrice, (t1_bid * count))
									set(BuyoutPrice, (t1_buyout * count))
								end
							elseif ( (t1_buyout * count) - rules.buyout2 <= 0 ) and ( (t1_buyout * count) - 10000 > 0 ) then
								set(StartPrice, ((t1_buyout * count) - 10000))
								set(BuyoutPrice, ((t1_buyout * count) - 1))
							elseif ( (t1_buyout * count) - rules.buyout2 > 0 ) and ( (t1_buyout * count) - 10000 <= 0 ) then
								if (t1_buyout * count) - rules.buyout2 > (t1_bid * count) then
									set(StartPrice, (t1_bid * count))
									set(BuyoutPrice, ((t1_buyout * count) - rules.buyout2))
								elseif (t1_buyout * count) - 1 > (t1_bid * count) then
									set(StartPrice, (t1_bid * count))
									set(BuyoutPrice, ((t1_buyout * count) - 1))
								elseif (t1_bid * count) - 1 > 0 then
									set(StartPrice, ((t1_bid * count) - 1))
									set(BuyoutPrice, (t1_buyout * count))
								else
									set(StartPrice, (t1_bid * count))
									set(BuyoutPrice, (t1_buyout * count))
								end
							else
								if (t1_buyout * count) - 1 > (t1_bid * count) then
									set(StartPrice, (t1_bid * count))
									set(BuyoutPrice, ((t1_buyout * count) - 1))
								elseif (t1_bid * count) - 1 > 0 then
									set(StartPrice, ((t1_bid * count) - 1))
									set(BuyoutPrice, (t1_buyout * count))
								else
									set(StartPrice, (t1_bid * count))
									set(BuyoutPrice, (t1_buyout * count))
								end
							end
						end
					else
						if (t1_buyout * count) - rules.buyout > 0 and (t1_bid * count) - rules.bid > 0 then
							if ( (t1_buyout * count) - rules.buyout >= (t1_bid * count) - rules.bid + rules.buyout ) then
								set(StartPrice, ((t1_bid * count) - rules.bid))
								set(BuyoutPrice, ((t1_buyout * count) - rules.buyout))
							else
								if ( (t1_buyout * count) - 1 >= (t1_bid * count) - rules.bid ) then
									set(StartPrice, ((t1_bid * count) - rules.bid))
									set(BuyoutPrice, ((t1_buyout * count) - 1))
								else
									if ( (t1_bid * count) - rules.bid - rules.buyout > 0 ) then
										set(StartPrice, ((t1_bid * count) - rules.bid - rules.buyout))
										set(BuyoutPrice, (t1_buyout * count))
									else
										if ( (t1_bid * count) - rules.bid > 0 ) then
											set(StartPrice, ((t1_bid * count) - rules.bid ))
											set(BuyoutPrice, (t1_buyout * count))
										else
											if ( (t1_bid * count) - 1 > 0 ) then
												set(StartPrice, ((t1_bid * count) - 1))
												set(BuyoutPrice, (t1_buyout * count))
											else
												set(StartPrice, (t1_bid * count))
												set(BuyoutPrice, (t1_buyout * count))
											end
										end
									end
								end
							end
						elseif (t1_buyout * count) - rules.buyout <= 0 and (t1_bid * count) - rules.bid > 0 then
							if ( (t1_buyout * count) - 1 >= (t1_bid * count) - rules.bid ) then
								set(StartPrice, ((t1_bid * count) - rules.bid))
								set(BuyoutPrice, ((t1_buyout * count) - 1))
							else
								if ( (t1_bid * count) - rules.bid - rules.buyout > 0 ) then
									set(StartPrice, ((t1_bid * count) - rules.bid - rules.buyout))
									set(BuyoutPrice, (t1_buyout * count))
								else
									if ( (t1_bid * count) - rules.bid > 0 ) then
										set(StartPrice, ((t1_bid * count) - rules.bid ))
										set(BuyoutPrice, (t1_buyout * count))
									else
										if ( (t1_bid * count) - 1 > 0 ) then
											set(StartPrice, ((t1_bid * count) - 1))
											set(BuyoutPrice, (t1_buyout * count))
										else
											set(StartPrice, (t1_bid * count))
											set(BuyoutPrice, (t1_buyout * count))
										end
									end
								end
							end
						elseif (t1_buyout * count) - rules.buyout > 0 and (t1_bid * count) - rules.bid <= 0 then
							if (t1_buyout * count) - rules.buyout >= (t1_bid * count) then
								set(StartPrice, (t1_bid * count))
								set(BuyoutPrice, ((t1_buyout * count) - rules.buyout))
							else
								if (t1_buyout * count) - 1 >= (t1_bid * count) then
									set(StartPrice, (t1_bid * count))
									set(BuyoutPrice, ((t1_buyout * count) - 1))
								else
									if (t1_bid * count) - 1 > 0 then
										set(StartPrice, ((t1_bid * count) - 1))
										set(BuyoutPrice, (t1_buyout * count))
									else
										set(StartPrice, (t1_bid * count))
										set(BuyoutPrice, (t1_buyout * count))
									end
								end
							end
						else
							if (t1_buyout * count) - 1 >= (t1_bid * count) then
								set(StartPrice, (t1_bid * count))
								set(BuyoutPrice, ((t1_buyout * count) - 1))
							elseif (t1_bid * count) - 1 > 0 then
								set(StartPrice, ((t1_bid * count) - 1))
								set(BuyoutPrice, (t1_buyout * count))
							else
								set(StartPrice, (t1_bid * count))
								set(BuyoutPrice, (t1_buyout * count))
							end
						end
					end
				end
			end
		end
	end
end

local function HasLaterFitSlot(bag, slot)
	local later_bag = {}
	if maxn(t3) > 0 then
		for i in pairs(t3) do
			later_bag[i] = {}
			for j in pairs(t3) do
				later_bag[i][j] = 1
			end
		end
	end

	local item = GetContainerItemID(bag, slot)
	local itemFamily = GetItemFamily(item)
	if select(9, GetItemInfo(item)) == "INVTYPE_BAG" then
	  itemFamily = 0
	end
	for i = 0, 4 do
		local bagFamily = select(2, GetContainerNumFreeSlots(i))
		if ( bagFamily == 0 or bit.band(itemFamily, bagFamily) > 0 ) then
			if i < bag and later_bag[i] then
				return true
			elseif i == bag and later_bag[i] then
				for k in pairs(later_bag[i]) do
					if k < slot then
						return true
					end
				end
			end
		end
	end
end

local function GetAuctionAlltimes()
	local alltimes = 0
	for i in pairs(t3) do
		if t3[i] then
			for j in pairs(t3[i]) do
				if t3[i][j] then
					if AHHelper.split > 0 and (GetFitSlot(GetContainerItemID(i, j)) or HasLaterFitSlot(i, j)) then
						alltimes = alltimes + ceil(t3[i][j]/AHHelper.split)
					else
						alltimes = alltimes + 1
					end
				end
			end
		end
	end
	return alltimes
end

local function DoAuction(bag, slot)
	AHHelper.nextslot = {bag, slot}
	PickupContainerItem(bag, slot)
	if not AHHelper.spliting then
		ClickAuctionSellItemButton()
		AutoSetCopper()
		AuctionsCreateAuctionButton_OnClick()
	end
end

local runOnce1, runOnce2 = 1, 1
local numBatchAuctions, totalAuctions = 0, 0
local computeOnce = 1
local currentPage = 0
local barWidth, lastbarWidth, barLeftTime = 0, 0, 0
local auction_times, auction_alltimes = 0, 0
local queryOnce
local autoauction = {Inscription=0,Elemental=0,Cloth=0,Leather=0,Mining=0,Herb=0,Enchanting=0,Gem=0,Medicine=0,Quest=0,All=0,}
function AHHelper:OnEvent()
	if "ADDON_LOADED" == event then
		if "Blizzard_GuildBankUI" == arg1 then
			if runOnce2 then
				runOnce2 = nil
				self:hookscript(GuildBankMessageFrame, "OnHyperlinkEnter", OnHyperlinkEnter)
				self:hookscript(GuildBankMessageFrame, "OnHyperlinkLeave", OnHyperlinkLeave)
				GuildBankMessageFrame.UpdateTooltip = UpdateTooltip
			end
		end
		if "Blizzard_AuctionUI" == arg1 then
			if runOnce1 then
				runOnce1 = nil
				ORG_ALPHA = AuctionFrame:GetAlpha()
				for i = 1, NUM_CONTAINER_FRAMES do
					local s = tostring('ContainerFrame'..i)
					tinsert(itembutton, s)
				end
				self:HookContainerFrameItemButton()
				--AuctionsItemButton:SetScript("OnEvent", AuctionSellItemButtonOnEvent)--11 3.35解决不能拍卖

				--BrowseShowOnCharacterText:SetText(EACHPRICE_TITLE)
				hooksecurefunc("BrowseButton_OnClick", BrowseButtonOnClick)
				hooksecurefunc("AuctionsButton_OnClick", AuctionsButtonOnClick)
				--hooksecurefunc("ContainerFrameItemButton_OnClick", AHHelper.AutoAuctionCompleted)
				--hooksecurefunc("ContainerFrameItemButton_OnModifiedClick", AHHelper.AutoAuctionCompleted)
				--AuctionsItemButton:RegisterForClicks("LeftButtonDown", "RightButtonDown")--11
				--AuctionsItemButton:SetScript("OnClick", function(this, button) AHHelper:AuctionItemButtonOnClick(button) end)--11
	
				_G.StaticPopupDialogs.BUYOUT_AUCTION.OnShow = AHHelper.ShowPrice
				_G.StaticPopupDialogs.BUYOUT_AUCTION.OnAccept = AHHelper.BrowseBuyOut
	
				BrowseBidButton:SetScript("OnClick", function()
					this:Disable()
					AHHelper:BrowseBid()
				end)
	
				_G.StaticPopupDialogs.CANCEL_AUCTION.OnShow = AHHelper.ShowPrice
				_G.StaticPopupDialogs.CANCEL_AUCTION.OnAccept = AHHelper.CancelAuctions
	
				ShowOnPlayerCheckButton:SetScript("OnEnter", function()
					GameTooltip:SetOwner(this, "ANCHOR_LEFT")
					GameTooltip:SetText(EACHPRICE_TOOLTIP, nil, nil, nil, nil, 1)
				end)
				ShowOnPlayerCheckButton:SetScript("OnClick", function() end)
				ShowOnPlayerCheckButton:SetScript("OnShow", function() end)

				BrowseSearchButton:SetScript("OnClick", function()
					self.query_completedtextFrame:Hide()
					BrowseSearchCountText:SetAlpha(ORG_ALPHA)
					BrowseSearchDotsText:SetAlpha(ORG_ALPHA)
					BrowseNoResultsText:SetAlpha(ORG_ALPHA)
					AuctionFrameBrowse_Search()
				end)
				BrowseName:SetScript("OnEnterPressed", function()
					self.query_completedtextFrame:Hide()
					BrowseSearchCountText:SetAlpha(ORG_ALPHA)
					BrowseSearchDotsText:SetAlpha(ORG_ALPHA)
					BrowseNoResultsText:SetAlpha(ORG_ALPHA)
					AuctionFrameBrowse_Search()
					BrowseName:ClearFocus()
				end)
				button0 = CreatButton(nil, AuctionFrameBrowse, QUERY_TEXT, 80, 22, "LEFT", "AuctionFrameMoneyFrame", "RIGHT", 4, 0)
				--button0 = CreatButton(nil, AuctionFrameBrowse, QUERY_TEXT, BrowseSearchButton:GetWidth(), BrowseSearchButton:GetHeight(), "RIGHT",  "BrowseSearchButton", "LEFT", 0, 0)
				button0:SetScript("OnClick", function()
					sparkTimer[1] = GetTime()
					for i = 2, 5 do
						sparkTimer[i] = sparkTimer[i-1] + sparkInterval
					end
					currentPage = 0
					queryOnce = nil
					querying = 1
					BrowseName:ClearFocus()
					BrowseMinLevel:ClearFocus()
					BrowseMaxLevel:ClearFocus()
					BrowseBidPriceGold:ClearFocus()
					BrowseBidPriceSilver:ClearFocus()
					BrowseBidPriceCopper:ClearFocus()
					numBatchAuctions, totalAuctions = 0, 0
					BrowseSearchButton:SetScript("OnUpdate", function() end)
					BrowseResetButton:SetScript("OnUpdate", function() end)
					BrowseName:SetScript("OnEnterPressed", function() end)
					self.query_auctionitemsFrame:Show()
					START_TIME = GetTime()
				end)
				button1 = CreatButton(nil, AuctionFrameAuctions, AUTOREMOVE_TEXT, 76, 22, "RIGHT", "AuctionsCancelAuctionButton", "LEFT", 4, 0)
				button1:SetScript("OnClick", function()
					StaticPopup_Show("AUTO_CANCELAUCTION")
				end)
				button2 = CreatButton(nil, AuctionFrameAuctions, AUTOAUCTION_TEXT, 76, 22, "RIGHT", button1, "LEFT", 2, 0)
				button2:SetScript("OnClick", function()
					AHHelper.autoauctionDialog:Show()
				end)
				button3 = CreatButton(nil, AuctionFrameAuctions, CLEARMEMORY_TEXT, 136, 22, "BOTTOMLEFT", 175, 14, "BOTTOM")
				button3:SetScript("OnClick", function()
					StaticPopup_Show("CLEAR_MEMORY")
				end)
				button4 = CreatButton(nil, AuctionFrameAuctions, REMOVEALL_TEXT, 76, 22, "LEFT", button3, "RIGHT", 2, 0)
				button4:SetScript("OnClick", function()
					StaticPopup_Show("CANCEL_ALLAUCTION")
				end)
				self:CreateQueryItemsFrame()
				self:CreateCompletedQueryTextFrame()
				self:CreateAutoAuctionFrame()
			end
		end
	elseif "VARIABLES_LOADED" == event then
		do
			PLAYER_NAME = UnitName("player")
			_,_,_,_,GLYPH,_,_,_,_,GEM,_,QUEST = GetAuctionItemClasses()
			ELEMENTAL, CLOTH, LEATHER, _, _, HERB, ENCHANTING  = GetAuctionItemSubClasses(6)
			MINING = strsub(select(4,GetAuctionItemSubClasses(6)), -6, -1)
			_,_,MEDICINE = GetAuctionItemSubClasses(4)
			ALL = _G["QUICKBUTTON_NAME_EVERYTHING"]
		end
		self:hookmethod(GameTooltip)
		self:hookmethod(ItemRefTooltip, "SetHyperlink")
		self:hookmethod(ShoppingTooltip1, "SetHyperlinkCompareItem")
		self:hookmethod(ShoppingTooltip1, "SetExistingSocketGem")
		self:hookmethod(ShoppingTooltip2, "SetHyperlinkCompareItem")
		self:hookmethod(GameTooltip3, "SetHyperlinkCompareItem")
		self:hookmethod(GameTooltip4, "SetHyperlinkCompareItem")
		if AtlasLootTooltip then
			self:hookmethod(AtlasLootTooltip, "SetHyperlink")
		end
		StaticPopupDialogs["AUTO_AUCTIONALL"] = {
			text = AUTO_AUCTIONALL_CONFIRMATION,
			button1 = YES,
			button2 = NO,
			OnAccept = function()
				autoauction.All = 1
				ClickAuctionSellItemButton()
				ClearCursor()
				AHHelper:SearchAutoAuctionItems()
				AHHelper:AutoAuction()
				sparkTimer[1] = GetTime()
				for i = 2, 5 do
					sparkTimer[i] = sparkTimer[i-1] + sparkInterval
				end
			end,
			OnCancel = function()
				AHHelper.autoauctionDialog:Show()
			end,
			showAlert = 1,
			timeout = 0,
			exclusive = 1,
			hideOnEscape = 1
		}
		StaticPopupDialogs["AUTO_CANCELAUCTION"] = {
			text = AUTO_CANCELAUCTION_CONFIRMATION,
			button1 = YES,
			button2 = NO,
			OnAccept = AHHelper.AutoRemove,
			showAlert = 1,
			timeout = 0,
			exclusive = 1,
			hideOnEscape = 1
		}
		StaticPopupDialogs["CANCEL_ALLAUCTION"] = {
			text = CANCEL_ALLAUCTION_CONFIRMATION,
			button1 = YES,
			button2 = NO,
			OnAccept = function()
				t5.id, t5.info = {}, {}
				removingall = 1
				AHHelper:RemoveAll()
			end,
			showAlert = 1,
			timeout = 0,
			exclusive = 1,
			hideOnEscape = 1
		}
		StaticPopupDialogs["CLEAR_MEMORY"] = {
			text = CLEAR_MEMORY_CONFIRMATION,
			button1 = YES,
			button2 = NO,
			OnAccept = AHHelper.ClearMemory,
			showAlert = 1,
			timeout = 0,
			exclusive = 1,
			hideOnEscape = 1
		}
		--_G.DISPLAY_ON_CHARACTER = EACHPRICE_TITLE
		self.split = 0
		self.nextslot = {}
		self:DumpBags()
		self:CreateAutoAuctionDialog()
		self:SetScript("OnUpdate", self.OnUpdate)
	elseif "AUCTION_HOUSE_SHOW" == event then
		do
			if BrowseSearchCountText then
				BrowseSearchCountText:SetAlpha(ORG_ALPHA)
			end
			if BrowseSearchDotsText then
				BrowseSearchDotsText:SetAlpha(ORG_ALPHA)
			end
			if AuctionsSearchCountText then
				AuctionsSearchCountText:SetAlpha(ORG_ALPHA)
			end
		end
		--self:DumpBags()
		--self:HookContainerFrameItemButton()
		self.isAHshown = 1
		ahColsed_doOnce = 1
	elseif "AUCTION_HOUSE_CLOSED" == event then
		StaticPopup_Hide("AUTO_CANCELAUCTION")
		StaticPopup_Hide("CANCEL_ALLAUCTION")
		StaticPopup_Hide("AUTO_AUCTIONALL")
		if self.autoauctionDialog then
			self.autoauctionDialog:Hide()
		end
		self.query_completedtextFrame:Hide()
		can_removeall, can_autoremove, checked_can_autoremove, checked_can_removeall = nil, nil, nil, nil
		self.isAHshown, bidding, removing, autoremoving, removingall = nil, nil, nil, nil, nil
		autoauction = {Inscription=0,Elemental=0,Cloth=0,Leather=0,Mining=0,Herb=0,Enchanting=0,Gem=0,Medicine=0,Quest=0,All=0,}
		t3 = {[0] = {}, [1] = {}, [2] = {}, [3] = {}, [4] = {}}
		t4.id, t4.info, t5.id, t5.info = {}, {}, {}, {}
		self:AutoAuctionCompleted()
		self:QueryCompleted()
		collectgarbage()
	elseif "CHAT_MSG_SYSTEM" == event then 
		if ERR_AUCTION_BID_PLACED == arg1 then
			tremove(t4.id)
			tremove(t4.info)
			if #t4.id > 0 then
				SetSelectedAuctionItem("list", t4.id[#t4.id])
			else
				bidding = nil
				SetSelectedAuctionItem("list", 0)
			end
		elseif ERR_AUCTION_REMOVED == arg1 then
			tremove(t5.id)
			tremove(t5.info)
			if #t5.id > 0 then
				SetSelectedAuctionItem("owner", t5.id[#t5.id])
			else
				removing = nil
				SetSelectedAuctionItem("owner", 0)
			end
		elseif ERR_AUCTION_STARTED == arg1 then
			-- do nothing!
		end
	elseif "AUCTION_ITEM_LIST_UPDATE" == event then
		self:DumpItemList()
		if (0 == querying) then
			self.query_auctionitemsFrame:Show()
			self.query_auctionitemsFrame.bar:Show()
			querying = 2
			numBatchAuctions, totalAuctions = GetNumAuctionItems("list")
		end
	end
	if "BAG_UPDATE" == event then
		if not self.spliting and auto_auctioning and maxn(self.nextslot) == 2 then
			if not GetContainerItemInfo(self.nextslot[1], self.nextslot[2]) then
				self.nextslot = {}
				auction_times = auction_times + 1
				if t1[LAST_ITEM_AUCTIONED] and t1[LAST_ITEM_AUCTIONED][LAST_ITEM_TEXTURE] then
					t1[LAST_ITEM_AUCTIONED][LAST_ITEM_TEXTURE].bid = ceil(LAST_ITEM_START_BID/LAST_ITEM_COUNT )
					t1[LAST_ITEM_AUCTIONED][LAST_ITEM_TEXTURE].buyout = ceil(LAST_ITEM_BUYOUT/LAST_ITEM_COUNT)
					t1[LAST_ITEM_AUCTIONED][LAST_ITEM_TEXTURE].owner = PLAYER_NAME
				end
				self:AutoAuction()
			end
		end
	end
	if "AUCTION_OWNED_LIST_UPDATE" == event then
		checked_can_autoremove, checked_can_removeall = nil, nil
		self:DumpOwnedList()
	end
end
AHHelper:RegisterEvent("ADDON_LOADED")
AHHelper:RegisterEvent("VARIABLES_LOADED")
AHHelper:RegisterEvent("AUCTION_HOUSE_SHOW")
AHHelper:RegisterEvent("AUCTION_HOUSE_CLOSED")
AHHelper:RegisterEvent("CHAT_MSG_SYSTEM")
AHHelper:RegisterEvent("AUCTION_ITEM_LIST_UPDATE")
AHHelper:RegisterEvent("AUCTION_OWNED_LIST_UPDATE")
AHHelper:RegisterEvent("BAG_UPDATE")
AHHelper:SetScript("OnEvent", AHHelper.OnEvent)

function AHHelper:DumpOwnedList()
	local name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner, saleStatus
	if GetNumAuctionItems("owner") > 0 then
		for i = GetNumAuctionItems("owner"), 1, -1 do
			local found
			name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner, saleStatus = GetAuctionItemInfo("owner", i)
			if "string"==type(name) and "string"==type(texture) and "number"==type(minBid) and "number"==type(bidAmount) and "number"==type(buyoutPrice) then
				if count > 0 then
					if (0 == bidAmount) and (0 == saleStatus) and (buyoutPrice > 0) then
						if t2[name] and t2[name][texture] then
							if (t2[name][texture].buyout > ceil(buyoutPrice/count)) or ( (t2[name][texture].bid > ceil(minBid/count)) and (t2[name][texture].buyout >= ceil(buyoutPrice/count)) ) then
								t2[name][texture].bid = ceil(minBid/count)
								t2[name][texture].buyout = ceil(buyoutPrice/count)
							end
						else
							if not t2[name] then
								t2[name] = pool:new()
							end
							t2[name][texture] = pool:new{
								bid = ceil(minBid/count),
								buyout = ceil(buyoutPrice/count),
								owner = PLAYER_NAME,
							}
							--print(t2[name])
							--print(t2[name][texture])
						end
						if t1[name] and t1[name][texture] then
							if t2[name][texture] == t1[name][texture] then
								--do nothing!
							elseif t2[name][texture] <= t1[name][texture] then
								t1[name][texture] = copy(t2[name][texture])
							end
						else
							if t1[name] then
								t1[name][texture] = copy(t2[name][texture])
							else
								t1[name] = pool:new()
								t1[name][texture] = copy(t2[name][texture])
							end
						end
						--print(t1[name])
						--print(t1[name][texture])
					end
				end
			end
		end
	end
	for k1, v1 in pairs(t2) do
		if "table"==type(v1) then
			for k2, v2 in pairs(v1) do
				local found
				if GetNumAuctionItems("owner") > 0 then
					for i = 1, GetNumAuctionItems("owner") do
						name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner, saleStatus = GetAuctionItemInfo("owner", i)
						if (0 == bidAmount) and (0 == saleStatus) and (buyoutPrice > 0) then
							if k1 == name and k2 == texture then
								found = true
								break
							end
						end
					end
				end
				if not found then
					if t1[k1] and t1[k1][k2] then
						if PLAYER_NAME == t1[k1][k2].owner then
							t1[k1][k2] = nil
							if 0 == maxn(t1[k1]) then
								t1[k1] = nil
							end
						end
					end
					t2[k1][k2] = nil
					if 0 == maxn(t2[k1]) then
						t2[k1] = nil
					end
				end
			end
		end
	end
end

function AHHelper:DumpItemList()
	local name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner
	for i = 1, NUM_AUCTION_ITEMS_PER_PAGE do
		name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner =  GetAuctionItemInfo("list", i)
		if "string"==type(name) and "string"==type(texture) and "number"==type(minBid) and "number"==type(bidAmount) and "number"==type(buyoutPrice) then
			if ( buyoutPrice > 0 ) then
				if t1[name] and t1[name][texture] then
					if bidAmount > 0 then
						minBid = bidAmount
					end
					if ( t1[name][texture].buyout > ceil(buyoutPrice/count) ) then
						t1[name][texture].bid = ceil(minBid/count)
						t1[name][texture].buyout = ceil(buyoutPrice/count)
						t1[name][texture].owner = owner or ""
					elseif ( t1[name][texture].buyout == ceil(buyoutPrice/count) ) and ( t1[name][texture].bid > ceil(minBid/count) ) then
						t1[name][texture].bid = ceil(minBid/count)
						t1[name][texture].owner = owner or ""
					end
				else
					if not t1[name] then
						t1[name] = pool:new()
					end
					t1[name][texture] = pool:new{
						bid = ceil(minBid/count),
						buyout = ceil(buyoutPrice/count),
						owner = owner or "",
					}
					--print("t1[" .. name .. "]" .. "=")
					--print(t1[name][texture])
				end
			end
		end
	end
	for k1, v1 in pairs(t1) do
		if "table"==type(v1) then
			for k2, v2 in pairs(v1) do
				if PLAYER_NAME == v2.owner then
					if not t2[k1] then
						t2[k1] = pool:new()
					end
					if not t2[k1][k2] then
						t2[k1][k2] = copy(v2)
					end
				end
			end
		end
	end
end

function AHHelper:UpdateTooltip(self, ...)
	if not rules.tip then return end
	local link = select(2, self:GetItem()) or ""
	local id = link:match("item:(%d+)")
	if id then
		local name, _, _, _, _, _, _, _, _, texture = GetItemInfo(id)
		if name and texture and ""~= name and ""~= texture then
			if t1[name] and t1[name][texture] and PLAYER_NAME == t1[name][texture].owner then
				self:AddDoubleLine(EACHPRICE_TEXT..": ", GSCToString(MoneyToGSC(t1[name][texture].buyout)), 1, .8, 0, 1, 1, 1)
				if t2[name] and t2[name][texture] then
					self:AddLine(AUCTIONED_TEXT, 0, 1, 0)
				else
					self:AddLine(NOAUCTION_TEXT, 1, 0, 0)
				end
				return
			else
				if t1[name] and t1[name][texture] and t2[name] and t2[name][texture] then
					if t2[name][texture] <= t1[name][texture] then
						self:AddDoubleLine(EACHPRICE_TEXT..": ", GSCToString(MoneyToGSC(t2[name][texture].buyout)), 1, .8, 0, 1, 1, 1)
						self:AddLine(AUCTIONED_TEXT, 0, 1, 0)
					else
						self:AddDoubleLine(EACHPRICE_TEXT..": ", GSCToString(MoneyToGSC(t1[name][texture].buyout)), 1, .8, 0, 1, 1, 1)
						self:AddLine(NOTLOWEST_TEXT, 1, 1, 0)
					end
				elseif t1[name] and t1[name][texture] then
					self:AddDoubleLine(EACHPRICE_TEXT..": ", GSCToString(MoneyToGSC(t1[name][texture].buyout)), 1, .8, 0, 1, 1, 1)
					if PLAYER_NAME == t1[name][texture].owner then
						self:AddLine(AUCTIONED_TEXT, 0, 1, 0)
					else
						self:AddLine(NOAUCTION_TEXT, 1, 0, 0)
					end
				elseif t2[name] and t2[name][texture] then
					self:AddDoubleLine(EACHPRICE_TEXT..": ", GSCToString(MoneyToGSC(t2[name][texture].buyout)), 1, .8, 0, 1, 1, 1)
					self:AddLine(AUCTIONED_TEXT, 0, 1, 0)
				end
			end
		end
	end
end

function AHHelper:DumpBags()
	if IsAddOnLoaded('ACUI_MyInventory') then
		local s = 'ACUI_MyInventoryFrame'
		local found
		for _, v in pairs(itembutton) do
			if v == s then
				found = true
				break
			end
		end
		if not found then
			tinsert(itembutton, s)
		end
	end
	if IsAddOnLoaded('ArkInventory') then
		local i = 1
		while true do
			if not _G['ARKINV_Frame'..i..'ContainerBag'] then break end
			local j = 1
			while true do
				if not _G['ARKINV_Frame'..i..'ContainerBag'..j] then break end
				local s = tostring('ARKINV_Frame'..i..'ContainerBag'..j)
				local found
				for _, v in pairs(itembutton) do
					if v == s then
						found = true
						break
					end
				end
				if not found then
					tinsert(itembutton, s)
				end
				j = j + 1
			end
			i = i + 1
		end
	end
	if IsAddOnLoaded('Baggins') then
		local i = 1
		while true do
			if not _G['BagginsBag'..i] then break end
			local j = 1
			while true do
				if not _G['BagginsBag'..i..'Section'..j] then break end
				local s = tostring('BagginsBag'..i..'Section'..j)
				local found
				for _, v in pairs(itembutton) do
					if v == s then
						found = true
						break
					end
				end
				if not found then
					tinsert(itembutton, s)
				end
				j = j + 1
			end
			i = i + 1
		end
	end
	if IsAddOnLoaded('Bagnon') then
		-- do nothing!
	end
	if IsAddOnLoaded('BaudBag') then
		local i = 1
		while true do
			if not _G['BaudBagSubBag'..i] then break end
			local s = tostring('BaudBagSubBag'..i)
			local found
			for _, v in pairs(itembutton) do
				if v == s then
					found = true
					break
				end
			end
			if not found then
				tinsert(itembutton, s)
			end
			i = i + 1
		end
	end
	if IsAddOnLoaded('Combuctor') then
		-- do nothing!
	end
	if IsAddOnLoaded('MyInventory') then
		-- do nothing!
	end
	if IsAddOnLoaded('OneBag') or IsAddOnLoaded('OneBag3') then
		local i = 0
		while true do
			if not _G['OneBagFrameBag'..i] then break end
			local s = tostring('OneBagFrameBag'..i)
			local found
			for _, v in pairs(itembutton) do
				if v == s then
					found = true
					break
				end
			end
			if not found then
				tinsert(itembutton, s)
			end
			i = i + 1
		end
	end
end

--[[ function AHHelper:AuctionItemButtonOnClick(button)
	if ( button == "RightButton" ) then
		ClickAuctionSellItemButton()
		ClearCursor()
	else
		ClickAuctionSellItemButton()
		AuctionsFrameAuctions_ValidateAuction()
		AutoSetCopper()
		AuctionsCreateAuctionButton:SetScript("OnClick", function()
			AuctionsCreateAuctionButton_OnClick()
			if not t1[LAST_ITEM_AUCTIONED] then
				t1[LAST_ITEM_AUCTIONED] = pool:new()
			end
			t1[LAST_ITEM_AUCTIONED][LAST_ITEM_TEXTURE] = pool:new{
				bid = ceil(LAST_ITEM_START_BID/LAST_ITEM_COUNT),
				buyout = ceil(LAST_ITEM_BUYOUT/LAST_ITEM_COUNT),
				owner = PLAYER_NAME,
			}
		end)
	end
end ]]

function AHHelper:ContainerFrameItemButtonPreClick(frame, button)
	if AuctionFrame and AuctionFrame:IsVisible() then
		self:AutoAuctionCompleted()
		if ( button == "RightButton" and not IsModifierKeyDown() ) then
			local item, _, locked = GetContainerItemInfo(frame:GetParent():GetID(), frame:GetID())
			if item and ( not locked ) and ( not SpellCanTargetItem() ) then
				AuctionFrameTab_OnClick(AuctionFrameTab3)
				if (AuctionsItemButton and AuctionsItemButton:IsVisible()) then
					PickupContainerItem(frame:GetParent():GetID(), frame:GetID())
					ClickAuctionSellItemButton()
					AutoSetCopper()
					ClearCursor()
				end
			end
		end
	end
end

function AHHelper:HookContainerFrameItemButton()
	for _, v in pairs(itembutton) do
		local i = 1
		while true do
			if not _G[v..'Item'..i] then break end
			local f = _G[v..'Item'..i]
			if (f) then
				f:SetScript('PreClick', function(this, button)
					AHHelper:ContainerFrameItemButtonPreClick(this, button)
				end)
			end
			i = i + 1
		end
	end
end

function AHHelper:hookscript(frame, script, func)
	if not frame or not script or not func then return end
	if frame:GetScript(script) then
		frame:HookScript(script, func)
	else
		frame:SetScript(script, func)
	end
end

function AHHelper:hookmethod(tip, method)
	if not tip then return end
	if method then
		for i, hook in ipairs(self.hooks) do
			hook(tip, method)
		end
	else
		for i, v in ipairs(self.methods) do
			for j, hook in ipairs(self.hooks) do
				hook(tip, v)
			end
		end
	end
end

local noQuerying_doOnce = 1
function AHHelper:UpdateQueryItemsFrame(elapsed)
	if querying then
		noQuerying_doOnce = 1
	end
	if ("list" == AuctionFrame.type) and AuctionFrameBrowse:IsVisible() and (1 == querying) then
		button0:Disable()
		SetSelectedAuctionItem("list", 0)
		BrowseScrollFrame:SetAlpha(0)
		BrowseSearchCountText:SetAlpha(0)
		BrowseSearchDotsText:SetAlpha(0)
		BrowseNoResultsText:SetAlpha(0)
		BrowsePrevPageButton:Disable()
		BrowseNextPageButton:Disable()
		BrowseSearchButton:Disable()
		BrowseResetButton:Disable()
		BrowseCloseButton:Disable()
		self.query_completedtextFrame:Hide()
		for i = 1, NUM_BROWSE_TO_DISPLAY do
			_G["BrowseButton"..i]:SetAlpha(0)
		end
		if ( not queryOnce ) then
			if CanSendAuctionQuery("list") then
				queryOnce = 1
				QueryAuctionItems(BrowseName:GetText(), BrowseMinLevel:GetText(), BrowseMaxLevel:GetText(), AuctionFrameBrowse.selectedInvtypeIndex, AuctionFrameBrowse.selectedClassIndex, AuctionFrameBrowse.selectedSubclassIndex, currentPage, IsUsableCheckButton:GetChecked(), UIDropDownMenu_GetSelectedValue(BrowseDropDown))
				querying = 0
			end
		end
	elseif ("list" == AuctionFrame.type) and AuctionFrameBrowse:IsVisible() and (2 == querying) then
		self.query_completedtextFrame:Hide()
		if 0 == numBatchAuctions then
			querying = 3
		else
			if queryOnce and CanSendAuctionQuery("list") then
				local finished = 0
				for i = 1, numBatchAuctions do
					local name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner =  GetAuctionItemInfo("list", i)
					if "string"==type(name) then
						if "string"==type(texture) and ""~=texture then
							if "number"==type(count) and count > 0 then
								if "number"==type(minBid) then
									if "number"==type(bidAmount) then
										if "number"==type(buyoutPrice) then
												finished = finished + 1
										end
									end
								end
							end
						end
					end
				end
				if finished == numBatchAuctions then
					queryOnce = nil
					querying = 1
					END_TIME = GetTime()
					currentPage = currentPage + 1
					local totalPages = ceil(totalAuctions / NUM_AUCTION_ITEMS_PER_PAGE)
					AVERAGE_TIME = (END_TIME - START_TIME)/currentPage
					ALL_TIME = AVERAGE_TIME*(totalPages + 1)
					barWidth = barWidth + 1/totalPages
				else
					numBatchAuctions, totalAuctions = GetNumAuctionItems("list")
				end
			end
		end
	elseif 3 == querying then
		self.query_completedtextFrame:SetFrameLevel(max(AuctionFrame:GetFrameLevel(), AuctionFrameBrowse:GetFrameLevel()) + 1)
		self.query_auctionitemsFrame:Hide()
		self.query_auctionitemsFrame.bar:Hide()
		self.query_completedtextFrame.text:SetText(format(COMPLETEDQUERY_TEXT, totalAuctions))
		self.query_completedtextFrame:Show()
		numBatchAuctions, totalAuctions = 0, 0
		querying = nil
	elseif (not querying) and (noQuerying_doOnce) then
		self:QueryCompleted()
	end
end

function AHHelper:UpdateQueryItems_and_AutoAuctionFrameStatusBar(elapsed)
	if self.query_auctionitemsFrame then
		if not self.query_auctionitemsFrame:IsVisible() then
			self.query_auctionitemsFrame.bar:Hide()
			self.query_auctionitemsFrame.text:Hide()
		elseif self.query_auctionitemsFrame:IsVisible() then
			local bar = self.query_auctionitemsFrame.bar
			local text = self.query_auctionitemsFrame.text
			self.timer = (self.timer or 0) + elapsed
			if self.timer > 3 then
				if ALL_TIME > 10 then
					if ALL_TIME + START_TIME - GetTime() <= 60 then
						if ALL_TIME + START_TIME - GetTime() <= 0 then
							text:SetText(format(QUERYING_TEXT1, 0))
						else
							if barLeftTime > 0 and barLeftTime < ALL_TIME + START_TIME - GetTime() then
								text:SetText(format(QUERYING_TEXT1, barLeftTime))
							else
								text:SetText(format(QUERYING_TEXT1, ALL_TIME + START_TIME - GetTime()))
								barLeftTime = ALL_TIME + START_TIME - GetTime()
							end
						end
					else
						if barLeftTime > 0 and barLeftTime < ALL_TIME + START_TIME - GetTime() then
							text:SetText(format(QUERYING_TEXT2, floor(barLeftTime/60)))
						else
							text:SetText(format(QUERYING_TEXT2, floor((ALL_TIME + START_TIME - GetTime())/60)))
							barLeftTime = ALL_TIME + START_TIME - GetTime()
						end
					end
				elseif ALL_TIME > 0 then
					text:SetText(QUERYING_TEXT0)
				else
					text:SetText(QUERYING_TEXT)
				end
			else
				if ALL_TIME > 10 then
					text:SetText(QUERYING_TEXT)
				elseif ALL_TIME > 0 then
					text:SetText(QUERYING_TEXT0)
				else
					text:SetText(QUERYING_TEXT)
				end
			end
			text:Show()
			if ( querying ) then
				if totalAuctions > 0 then
					local totalPages = ceil(totalAuctions / NUM_AUCTION_ITEMS_PER_PAGE)
					if currentPage >= 1 then
						if lastbarWidth > 0 and barWidth + (GetTime() - END_TIME)/AVERAGE_TIME/totalPages < lastbarWidth then
							if lastbarWidth >= 1 then
								bar.statusbar:SetPoint( "CENTER", self.query_auctionitemsFrame, 80, -60 )
								bar.statusbar:SetWidth( 170 )
							else
								bar.statusbar:SetPoint( "CENTER", self.query_auctionitemsFrame, 85*lastbarWidth - 5, -60 )
								bar.statusbar:SetWidth( 170*lastbarWidth + .001 )
							end
						else
							if barWidth + (GetTime() - END_TIME)/AVERAGE_TIME/totalPages >= 1 then
								bar.statusbar:SetPoint( "CENTER", self.query_auctionitemsFrame, 80, -60 )
								bar.statusbar:SetWidth( 170 )
							else
								bar.statusbar:SetPoint( "CENTER", self.query_auctionitemsFrame, 85*(barWidth + (GetTime() - END_TIME)/AVERAGE_TIME/totalPages) - 5, -60 )
								bar.statusbar:SetWidth( 170*( barWidth + (GetTime() - END_TIME)/AVERAGE_TIME/totalPages ) + .001 )
							end
							lastbarWidth = barWidth + (GetTime() - END_TIME)/AVERAGE_TIME/totalPages
						end
					else
						bar.statusbar:SetPoint( "CENTER", self.query_auctionitemsFrame, 85*currentPage/totalPages - 5, -60 )
						bar.statusbar:SetWidth( 170*currentPage/totalPages + .001 )
					end
					bar.statusbar:Show()
				else
					bar.statusbar:Hide()
				end
			end
			bar:Show()
		end
	end

	if self.autoauctionFrame then
		if not self.autoauctionFrame:IsVisible() then
			self.autoauctionFrame.bar:Hide()
			self.autoauctionFrame.text:Hide()
		elseif self.autoauctionFrame:IsVisible() then
			local bar = self.autoauctionFrame.bar
			local text = self.autoauctionFrame.text
			bar:Show()
			text:Show()
			if ( auto_auctioning )  then
				if auction_alltimes > 0 then
					if (auction_times + 1)/auction_alltimes >= 1 then
						bar.statusbar:SetPoint( "CENTER", self.autoauctionFrame, 90, -60 )
						bar.statusbar:SetWidth( 170 )
					else
						bar.statusbar:SetPoint( "CENTER", self.autoauctionFrame, 85*(auction_times + 1)/auction_alltimes + 5, -60 )
						bar.statusbar:SetWidth( 170*(auction_times + 1)/auction_alltimes + .001 )
					end
					bar.statusbar:Show()
				else
					bar.statusbar:Hide()
				end
			end
		end
	end
end

function AHHelper:UpdateQueryItems_and_AutoAuctionFrameSpark(elapsed)
	if self.query_auctionitemsFrame then
		if not self.query_auctionitemsFrame:IsVisible() then
			self.query_auctionitemsFrame.bar:Hide()
			self.query_auctionitemsFrame.text:Hide()
		elseif self.query_auctionitemsFrame:IsVisible() then
			local bar = self.query_auctionitemsFrame.bar
			local text = self.query_auctionitemsFrame.text
			self.timer = (self.timer or 0) + elapsed
			if self.timer > 3 then
				if ALL_TIME > 10 then
					if ALL_TIME + START_TIME - GetTime() <= 60 then
						if ALL_TIME + START_TIME - GetTime() <= 0 then
							text:SetText(format(QUERYING_TEXT1, 0))
						else
							if barLeftTime > 0 and barLeftTime < ALL_TIME + START_TIME - GetTime() then
								text:SetText(format(QUERYING_TEXT1, barLeftTime))
							else
								text:SetText(format(QUERYING_TEXT1, ALL_TIME + START_TIME - GetTime()))
								barLeftTime = ALL_TIME + START_TIME - GetTime()
							end
						end
					else
						if barLeftTime > 0 and barLeftTime < ALL_TIME + START_TIME - GetTime() then
							text:SetText(format(QUERYING_TEXT2, floor(barLeftTime/60)))
						else
							text:SetText(format(QUERYING_TEXT2, floor((ALL_TIME + START_TIME - GetTime())/60)))
							barLeftTime = ALL_TIME + START_TIME - GetTime()
						end
					end
				elseif ALL_TIME > 0 then
					text:SetText(QUERYING_TEXT0)
				else
					text:SetText(QUERYING_TEXT)
				end
			else
				if ALL_TIME > 10 then
					text:SetText(QUERYING_TEXT)
				elseif ALL_TIME > 0 then
					text:SetText(QUERYING_TEXT0)
				else
					text:SetText(QUERYING_TEXT)
				end
			end
			text:Show()
			if ( querying ) then
				if totalAuctions > 0 then
					for i = 1, 5 do
						if GetTime() - sparkTimer[i] < 0 then
							bar["spark"..i]:Hide()
						else
							bar["spark"..i]:Show()
						end
						bar["spark"..i]:SetPoint("CENTER", self.query_auctionitemsFrame, ((GetTime() - sparkTimer[i])/5*(bar.border:GetWidth() - 12)) - 4, -60)
						if GetTime() - sparkTimer[i] >= 5 then
							if 1 == i then
								sparkTimer[i] = GetTime()
							else
								sparkTimer[i] = sparkTimer[i-1] + sparkInterval
							end
						end
					end
				else
					for i = 1, 5 do
						bar["spark"..i]:Hide()
					end
				end
			end
			bar:Show()
		end
	end

	if self.autoauctionFrame then
		if not self.autoauctionFrame:IsVisible() then
			self.autoauctionFrame.bar:Hide()
			self.autoauctionFrame.text:Hide()
		elseif self.autoauctionFrame:IsVisible() then
			local bar = self.autoauctionFrame.bar
			local text = self.autoauctionFrame.text
			bar:Show()
			text:Show()
			if ( auto_auctioning )  then
				for i = 1, 5 do
					if GetTime() - sparkTimer[i] < 0 then
						bar["spark"..i]:Hide()
					else
						bar["spark"..i]:Show()
					end
					bar["spark"..i]:SetPoint("CENTER", self.autoauctionFrame, ((GetTime() - sparkTimer[i])/5*(bar.border:GetWidth() - 12)) + 6, -60)
					if GetTime() - sparkTimer[i] >= 5 then
						if 1 == i then
							sparkTimer[i] = GetTime()
						else
							sparkTimer[i] = sparkTimer[i-1] + sparkInterval
						end
					end
				end
			end
		end
	end
end

function AHHelper:CreateQueryItemsFrame()
	--frame
	local frame = CreateFrame("frame", nil, UIParent)
	frame:SetFrameStrata("MEDIUM")
	frame:SetFrameLevel(AuctionFrame:GetFrameLevel() + 1)
	frame:SetWidth(852)
	frame:SetHeight(477)
	frame:EnableMouse(true)
	frame:SetToplevel(true)
	frame:SetPoint("CENTER", AuctionFrame, 0, -7)
	local backdrop = {
		bgFile="",
		edgeFile="",
		tile = true,
		tileSize = 32,
		edgeSize = 32,
		insets = { left = 2, right = 2, top = 2, bottom = 2 },
	}
	frame:SetBackdrop(backdrop)
	--fontstring
	frame.text = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	frame.text:SetWidth(160)
	frame.text:SetPoint("CENTER", frame, 95, 44)
	--bar
	frame.bar = CreateFrame("frame")
	frame.bar:SetFrameStrata("MEDIUM")
	frame.bar:EnableMouse(true)
	frame.bar:SetToplevel(true)
	--statusbar
	frame.bar.statusbar = frame.bar:CreateTexture(nil, "BACKGROUND")
	frame.bar.statusbar:SetTexture("Interface\\TargetingFrame\\UI-StatusBar")
	frame.bar.statusbar:SetHeight(16)
	frame.bar.statusbar:SetVertexColor(0, 1, 0)
	--border
	frame.bar.border = frame.bar:CreateTexture(nil, "ARTWORK")
	frame.bar.border:SetTexture("Interface\\Tooltips\\UI-StatusBar-Border")
	frame.bar.border:SetWidth(180)
	frame.bar.border:SetHeight(24)
	frame.bar.border:SetPoint("CENTER", frame, 80, -60)
	--spark
	frame.bar.spark1 = frame.bar:CreateTexture(nil, "BACKGROUND")
	frame.bar.spark1:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
	frame.bar.spark1:SetWidth(10)
	frame.bar.spark1:SetHeight(24)
	frame.bar.spark2 = frame.bar:CreateTexture(nil, "BACKGROUND")
	frame.bar.spark2:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
	frame.bar.spark2:SetWidth(10)
	frame.bar.spark2:SetHeight(24)
	frame.bar.spark3 = frame.bar:CreateTexture(nil, "BACKGROUND")
	frame.bar.spark3:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
	frame.bar.spark3:SetWidth(10)
	frame.bar.spark3:SetHeight(24)
	frame.bar.spark4 = frame.bar:CreateTexture(nil, "BACKGROUND")
	frame.bar.spark4:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
	frame.bar.spark4:SetWidth(10)
	frame.bar.spark4:SetHeight(24)
	frame.bar.spark5 = frame.bar:CreateTexture(nil, "BACKGROUND")
	frame.bar.spark5:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
	frame.bar.spark5:SetWidth(10)
	frame.bar.spark5:SetHeight(24)
	--button
	frame.button = CreatButton(nil, frame, CANCEL, 80, 22, "CENTER", frame, 95, -130)
	frame.button:SetScript("OnClick", function()
		querying = nil
		frame:Hide()
		BrowseSearchCountText:SetAlpha(ORG_ALPHA)
		BrowseSearchDotsText:SetAlpha(ORG_ALPHA)
		BrowseNoResultsText:SetAlpha(ORG_ALPHA)
		if self.query_completedtextFrame then
			self.query_completedtextFrame:Hide()
		end
	end)
	frame:Hide()
	frame.bar:Hide()
	self.query_auctionitemsFrame = frame
end

function AHHelper:CreateCompletedQueryTextFrame()
	local frame = CreateFrame("frame", nil, UIParent)
	frame:SetFrameStrata("MEDIUM")
	frame:SetFrameLevel(AuctionFrame:GetFrameLevel() + 1)
	frame:SetWidth(852)
	frame:SetHeight(477)
	frame:SetToplevel(true)
	frame.text = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	frame.text:SetPoint("CENTER", AuctionFrame, 95, 37)
	frame:Hide()
	self.query_completedtextFrame = frame
end

function AHHelper:CreateAutoAuctionFrame()
	local frame = CreateFrame("frame", nil, UIParent)
	frame:SetFrameStrata("MEDIUM")
	frame:SetFrameLevel(AuctionFrame:GetFrameLevel() + 1)
	frame:SetWidth(852)
	frame:SetHeight(477)
	frame:EnableMouse(true)
	frame:SetToplevel(true)
	frame:SetPoint("CENTER", AuctionFrame, 0, -7)
	local backdrop = {
		bgFile="",
		edgeFile="",
		tile = true,
		tileSize = 32,
		edgeSize = 32,
		insets = { left = 2, right = 2, top = 2, bottom = 2 },
	}
	frame:SetBackdrop(backdrop)
	--fontstring
	frame.text = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	frame.text:SetWidth(160)
	frame.text:SetText(AUCTIONING_TEXT)
	frame.text:SetPoint("CENTER", frame, 105, 44)
	--bar
	frame.bar = CreateFrame("frame")
	frame.bar:SetFrameStrata("MEDIUM")
	frame.bar:EnableMouse(true)
	frame.bar:SetToplevel(true)
	--statusbar
	frame.bar.statusbar = frame.bar:CreateTexture(nil, "BACKGROUND")
	frame.bar.statusbar:SetTexture("Interface\\TargetingFrame\\UI-StatusBar")
	frame.bar.statusbar:SetHeight(16)
	frame.bar.statusbar:SetVertexColor(0, 1, 0)
	--border
	frame.bar.border = frame.bar:CreateTexture(nil, "ARTWORK")
	frame.bar.border:SetTexture("Interface\\Tooltips\\UI-StatusBar-Border")
	frame.bar.border:SetWidth(180)
	frame.bar.border:SetHeight(24)
	frame.bar.border:SetPoint("CENTER", frame, 90, -60)
	--spark
	frame.bar.spark1 = frame.bar:CreateTexture(nil, "BACKGROUND")
	frame.bar.spark1:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
	frame.bar.spark1:SetWidth(10)
	frame.bar.spark1:SetHeight(24)
	frame.bar.spark2 = frame.bar:CreateTexture(nil, "BACKGROUND")
	frame.bar.spark2:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
	frame.bar.spark2:SetWidth(10)
	frame.bar.spark2:SetHeight(24)
	frame.bar.spark3 = frame.bar:CreateTexture(nil, "BACKGROUND")
	frame.bar.spark3:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
	frame.bar.spark3:SetWidth(10)
	frame.bar.spark3:SetHeight(24)
	frame.bar.spark4 = frame.bar:CreateTexture(nil, "BACKGROUND")
	frame.bar.spark4:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
	frame.bar.spark4:SetWidth(10)
	frame.bar.spark4:SetHeight(24)
	frame.bar.spark5 = frame.bar:CreateTexture(nil, "BACKGROUND")
	frame.bar.spark5:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
	frame.bar.spark5:SetWidth(10)
	frame.bar.spark5:SetHeight(24)
	--button
	frame.button = CreatButton(nil, frame, CANCEL, 80, 22, "CENTER", frame, 105, -130)
	frame.button:SetScript("OnClick", function()
		frame:Hide()
		self:AutoAuctionCompleted()
	end)
	frame:Hide()
	frame.bar:Hide()
	self.autoauctionFrame = frame
end

function AHHelper:CreateAutoAuctionDialog()
	--frame
	local frame = CreateFrame("editbox", nil, UIParent)
	frame:SetFrameStrata("DIALOG")
	frame:SetWidth(320)
	frame:SetHeight(172)
	frame:SetPoint("CENTER", UIParent, 0, 250)
	frame:EnableMouse(false)
	frame:EnableKeyboard(true)
	frame:SetToplevel(true)
	frame:SetScript("OnEscapePressed", function(this)
		this:Hide()
	end)
	frame:SetScript("OnEditFocusGained", function(this)
		this:ClearFocus()
		this.SliptBox:SetFocus()
	end)
	--backdrop
	local backdrop = {
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
		edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
		tile = true,
		tileSize = 32,
		edgeSize = 32,
		insets = { left = 11, right = 12, top = 12, bottom = 11 },
	}
	frame:SetBackdrop(backdrop)
	--fontstring
	local str = frame:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
	str:SetWidth(290)
	str:SetHeight(0)
	str:SetPoint("CENTER", frame, 0, 45)
	str:SetText(AUTO_AUCTION_CONFIRMATION)
	--alerticon
	local icon = frame:CreateTexture(nil, "ARTWORK")
	icon:SetTexture("Interface\\DialogFrame\\DialogAlertIcon")
	icon:SetWidth(64)
	icon:SetHeight(64)
	icon:SetPoint("TOPLEFT", frame, 4, -6)
	--edit box
	frame.SliptBox = CreateFrame("editbox", nil, frame, "InputBoxTemplate")
	frame.SliptBox:SetWidth(40)
	frame.SliptBox:SetHeight(22)
	frame.SliptBox:SetPoint("BOTTOMLEFT", frame, 120, 23)
	frame.SliptBox:EnableMouse(true)
	frame.SliptBox:SetMaxLetters(3)
	frame.SliptBox:SetNumeric(true)
	frame.SliptBox:SetAutoFocus(false)
	frame.SliptBox:SetScript("OnUpdate", function(this)
		if this:IsVisible() and this:HasFocus() then
			AHHelper.split = tonumber(this:GetText()=="" and 0 or this:GetText())
		end
	end)
	frame.SliptBox:SetScript("OnShow", function(this)
		this:SetText(tostring(AHHelper.split))
		this:HighlightText(0, strlen(this:GetText()))
		this:SetFocus()
		this:SetCursorPosition(strlen(this:GetText()))
		this:SetScript("OnUpdate", function(this)
			if this:IsVisible() and this:HasFocus() then
				AHHelper.split = tonumber(this:GetText()=="" and 0 or this:GetText())
			end
		end)
	end)
	frame.SliptBox:SetScript("OnHide", function(this)
		this:SetScript("OnUpdate", nil)
	end)
	frame.SliptBox:SetScript("OnEscapePressed", function(this)
		this:ClearFocus()
	end)
	frame.SliptBox:SetScript("OnEnterPressed", function(this)
		this:ClearFocus()
	end)
	frame.SliptBox:SetScript("OnEditFocusLost", function(this)
		this:HighlightText(0, 0)
		if this:GetText()=="" then
			AHHelper.split = 0
			this:SetText('0')
		end
	end)
	frame.l_text = frame:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
	frame.l_text:SetPoint("RIGHT", frame.SliptBox, "LEFT", -10, 0)
	frame.l_text:SetText(SPLITE_TEXT_LEFT)
	frame.r_text = frame:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
	frame.r_text:SetPoint("LEFT", frame.SliptBox, "RIGHT", 2, 0)
	frame.r_text:SetText(SPLITE_TEXT_RIGHT)
	--buttons
	local CloseButton = CreatButton(nil, frame, CANCEL, 40, 22, "BOTTOMRIGHT", -23, 23)
	CloseButton:SetScript("OnClick", function()
		frame:Hide()
	end)
	local GlyphButton = CreatButton(nil, frame, GLYPH, 40, 22, "TOPLEFT", 56, -63)
	GlyphButton:SetScript("OnClick", function()
		autoauction.Inscription = 1
		ClickAuctionSellItemButton()
		ClearCursor()
		AHHelper:SearchAutoAuctionItems()
		AHHelper:AutoAuction()
		frame:Hide()
		sparkTimer[1] = GetTime()
		for i = 2, 5 do
			sparkTimer[i] = sparkTimer[i-1] + sparkInterval
		end
	end)
	local ElementalButton = CreatButton(nil, frame, ELEMENTAL, 40, 22, "LEFT", GlyphButton, "RIGHT", 2, 0)
	ElementalButton:SetScript("OnClick", function()
		autoauction.Elemental = 1
		ClickAuctionSellItemButton()
		ClearCursor()
		AHHelper:SearchAutoAuctionItems()
		AHHelper:AutoAuction()
		frame:Hide()
		sparkTimer[1] = GetTime()
		for i = 2, 5 do
			sparkTimer[i] = sparkTimer[i-1] + sparkInterval
		end
	end)
	local ClothButton = CreatButton(nil, frame, CLOTH, 40, 22, "LEFT", ElementalButton, "RIGHT", 2, 0)
	ClothButton:SetScript("OnClick", function()
		autoauction.Cloth = 1
		ClickAuctionSellItemButton()
		ClearCursor()
		AHHelper:SearchAutoAuctionItems()
		AHHelper:AutoAuction()
		frame:Hide()
		sparkTimer[1] = GetTime()
		for i = 2, 5 do
			sparkTimer[i] = sparkTimer[i-1] + sparkInterval
		end
	end)
	local SkinButton = CreatButton(nil, frame, LEATHER, 40, 22, "LEFT", ClothButton, "RIGHT", 2, 0)
	SkinButton:SetScript("OnClick", function()
		autoauction.Leather = 1
		ClickAuctionSellItemButton()
		ClearCursor()
		AHHelper:SearchAutoAuctionItems()
		AHHelper:AutoAuction()
		frame:Hide()
		sparkTimer[1] = GetTime()
		for i = 2, 5 do
			sparkTimer[i] = sparkTimer[i-1] + sparkInterval
		end
	end)
	local OreButton = CreatButton(nil, frame, MINING, 40, 22, "LEFT", SkinButton, "RIGHT", 2, 0)
	OreButton:SetScript("OnClick", function()
		autoauction.Mining = 1
		ClickAuctionSellItemButton()
		ClearCursor()
		AHHelper:SearchAutoAuctionItems()
		AHHelper:AutoAuction()
		frame:Hide()
		sparkTimer[1] = GetTime()
		for i = 2, 5 do
			sparkTimer[i] = sparkTimer[i-1] + sparkInterval
		end
	end)
	local HerbButton = CreatButton(nil, frame, HERB, 40, 22, "TOP", GlyphButton, "BOTTOM", 0, -2)
	HerbButton:SetScript("OnClick", function()
		autoauction.Herb = 1
		ClickAuctionSellItemButton()
		ClearCursor()
		AHHelper:SearchAutoAuctionItems()
		AHHelper:AutoAuction()
		frame:Hide()
		sparkTimer[1] = GetTime()
		for i = 2, 5 do
			sparkTimer[i] = sparkTimer[i-1] + sparkInterval
		end
	end)
	local EnchantButton = CreatButton(nil, frame, ENCHANTING , 40, 22, "LEFT", HerbButton, "RIGHT", 2, 0)
	EnchantButton:SetScript("OnClick", function()
		autoauction.Enchanting = 1
		ClickAuctionSellItemButton()
		ClearCursor()
		AHHelper:SearchAutoAuctionItems()
		AHHelper:AutoAuction()
		frame:Hide()
		sparkTimer[1] = GetTime()
		for i = 2, 5 do
			sparkTimer[i] = sparkTimer[i-1] + sparkInterval
		end
	end)
	local MedicineButton = CreatButton(nil, frame, MEDICINE , 40, 22, "LEFT", EnchantButton, "RIGHT", 2, 0)
	MedicineButton:SetScript("OnClick", function()
		autoauction.Medicine = 1
		ClickAuctionSellItemButton()
		ClearCursor()
		AHHelper:SearchAutoAuctionItems()
		AHHelper:AutoAuction()
		frame:Hide()
		sparkTimer[1] = GetTime()
		for i = 2, 5 do
			sparkTimer[i] = sparkTimer[i-1] + sparkInterval
		end
	end)
	local GemButton = CreatButton(nil, frame, GEM , 40, 22, "LEFT", MedicineButton, "RIGHT", 2, 0)
	GemButton:SetScript("OnClick", function()
		autoauction.Gem = 1
		ClickAuctionSellItemButton()
		ClearCursor()
		AHHelper:SearchAutoAuctionItems()
		AHHelper:AutoAuction()
		frame:Hide()
		sparkTimer[1] = GetTime()
		for i = 2, 5 do
			sparkTimer[i] = sparkTimer[i-1] + sparkInterval
		end
	end)
	local QuestButton = CreatButton(nil, frame, QUEST , 40, 22, "LEFT", GemButton, "RIGHT", 2, 0)
	QuestButton:SetScript("OnClick", function()
		autoauction.Quest = 1
		ClickAuctionSellItemButton()
		ClearCursor()
		AHHelper:SearchAutoAuctionItems()
		AHHelper:AutoAuction()
		frame:Hide()
		sparkTimer[1] = GetTime()
		for i = 2, 5 do
			sparkTimer[i] = sparkTimer[i-1] + sparkInterval
		end
	end)
	local AllButton = CreatButton(nil, frame, ALL , 40, 22, "RIGHT", CloseButton, "LEFT", -2, 0)
	AllButton:SetScript("OnClick", function()
		frame:Hide()
		StaticPopup_Show("AUTO_AUCTIONALL")
	end)
	frame:Hide()
	self.autoauctionDialog = frame
end

function AHHelper:BrowseBuyOut()
	bidding = 1
	if "list" == AuctionFrame.type and AuctionFrameBrowse:IsVisible() then
		local offset = FauxScrollFrame_GetOffset(BrowseScrollFrame)
		if #t4.id > 0 then
			_sort(t4)
			for i = #t4.id, 1, -1 do
				local a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12 = GetAuctionItemInfo(AuctionFrame.type, t4.id[i])
				if _compare(t4.info[i], a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12) then
					PlaceAuctionBid(AuctionFrame.type, t4.id[i], t4.info[i][9])
				else
					tremove(t4.id, i)
					tremove(t4.info, i)
				end
			end
		end
	elseif "bidder" == AuctionFrame.type and AuctionFrameBid:IsVisible() then
		PlaceAuctionBid(AuctionFrame.type, GetSelectedAuctionItem("bidder"), AuctionFrame.buyoutPrice)
	end
end

function AHHelper:CancelAuctions()
	removing = 1
	if AuctionFrame:IsVisible() and AuctionFrameAuctions:IsVisible() then
		if #t5.id > 0 then
			_sort(t5)
			for i = #t5.id, 1, -1 do
				local a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13 = GetAuctionItemInfo("owner", t5.id[i])
				if _compare(t5.info[i], a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) then
					CancelAuction(t5.id[i])
				else
					tremove(t5.id, i)
					tremove(t5.info, i)
				end
			end
		end
	end
end

function AHHelper:ShowPrice()
	if "list" == AuctionFrame.type and AuctionFrameBrowse:IsVisible() then
		local allPrice = 0
		if #t4.id > 1 then
			for i = 1, #t4.id do
				local oneprice = t4.info[i][9]
				if 0 == oneprice then
					allPrice = 0
					break
				else
					allPrice = allPrice + oneprice
				end
			end
			MoneyFrame_Update(this:GetName().."MoneyFrame", allPrice)
		elseif 1 == #t4.id then
			MoneyFrame_Update(this:GetName().."MoneyFrame", t4.info[1][9])
		end
		AuctionFrameBrowse_Update()
		AHHelper:UpdateBidButton()
	elseif "bidder" == AuctionFrame.type and AuctionFrameBid:IsVisible() then
		MoneyFrame_Update(this:GetName().."MoneyFrame", AuctionFrame.buyoutPrice)
		AuctionFrameBrowse_Update()
		AHHelper:UpdateBidButton()
	elseif AuctionFrame:IsVisible() and AuctionFrameAuctions:IsVisible() then
		local allCancelPrice = 0
		if #t5.id > 0 then
			for i = 1, #t5.id do
				allCancelPrice = allCancelPrice + t5.info[i][10]
			end
			MoneyFrame_Update(this:GetName().."MoneyFrame", floor(allCancelPrice * .05))
		end
		if ( allCancelPrice > 0 ) then
			_G.StaticPopupDialogs.CANCEL_AUCTION.text = CANCEL_AUCTION_CONFIRMATION_MONEY
		else
			_G.StaticPopupDialogs.CANCEL_AUCTION.text = CANCEL_AUCTION_CONFIRMATION
		end
		AuctionFrameAuctions_Update()
		AHHelper:UpdateCancelAuctionButton()
	end
end

function AHHelper:BrowseBid()
	bidding = 1
	local offset = FauxScrollFrame_GetOffset(BrowseScrollFrame)
	if #t4.id > 0 then
		_sort(t4)
		local bidprice
		for i = #t4.id, 1, -1 do
			local a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12 = GetAuctionItemInfo(AuctionFrame.type, t4.id[i])
			if _compare(t4.info[i], a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12) then
				if 0 == t4.info[i][10] then
					bidprice = t4.info[i][7]
				else
					bidprice = t4.info[i][10] + t4.info[i][8]
				end
				if 1 == #t4.id and bidprice ~= MoneyInputFrame_GetCopper(BrowseBidPrice) then
					PlaceAuctionBid("list", GetSelectedAuctionItem("list"), MoneyInputFrame_GetCopper(BrowseBidPrice))
				else
					PlaceAuctionBid(AuctionFrame.type, t4.id[i], bidprice)
				end
			else
				tremove(t4.id, i)
				tremove(t4.info, i)
			end
		end
	end
end

local ahColsed_doOnce = 1
local ahBrowseClosed_doOnce = 1
local ahAuctionClosed_doOnce = 1
local dumpbags_doOnce
function AHHelper:OnUpdate(elapsed)
	if AuctionFrame and AuctionFrame:IsVisible() then
		if not dumpbags_doOnce then
			self:DumpBags()
			self:HookContainerFrameItemButton()
			dumpbags_doOnce = 1
		end
	else
		dumpbags_doOnce = nil
	end

	if AuctionFrame then
		if ( AuctionFrame:IsVisible() and AuctionFrameAuctions:IsVisible() ) then
			ORG_ALPHA = AuctionFrameAuctions:GetAlpha()
		elseif ( "list" == AuctionFrame.type and AuctionFrameBrowse:IsVisible() ) then
			ORG_ALPHA = AuctionFrameBrowse:GetAlpha()
		else
			ORG_ALPHA = AuctionFrame:GetAlpha()
		end
		if ShowOnPlayerCheckButtonText:GetText() ~= EACHPRICE_TITLE then
			ShowOnPlayerCheckButtonText:SetText(EACHPRICE_TITLE)
		end
		--[[
		if select(4, BrowseSearchButton:GetPoint())<=63.8 or select(4, BrowseSearchButton:GetPoint())>=64.2 then
			BrowseSearchButton:SetPoint("TOPRIGHT",  AuctionFrameBrowse, "TOPRIGHT", 64, select(5, BrowseSearchButton:GetPoint()))
		end
		if select(5, BrowseNextPageButton:GetPoint())<=-57.2 or select(5, BrowseNextPageButton:GetPoint())>=-56.8 then
			BrowseNextPageButton:SetPoint("TOPRIGHT",  AuctionFrameBrowse, "TOPRIGHT", select(4, BrowseNextPageButton:GetPoint()), -57)
		end
		if select(5, BrowsePrevPageButton:GetPoint())<=-57.2 or select(5, BrowsePrevPageButton:GetPoint())>=-56.8 then
			BrowsePrevPageButton:SetPoint("TOPLEFT", AuctionFrameBrowse, "TOPLEFT", select(4, BrowsePrevPageButton:GetPoint()), -57)
		end
		]]
	end

	if AuctionFrame and (not AuctionFrame:IsVisible()) then
		bidding, removing, autoremoving, removingall, auto_bidding, querying = nil,nil,nil,nil,nil,nil
		self.isAHshown = nil
		StaticPopup_Hide("AUTO_AUCTIONALL")
		if self.query_completedtextFrame then
			if self.query_completedtextFrame:IsVisible() then
				self.query_completedtextFrame:Hide()
			end
		end
		if self.autoauctionDialog:IsVisible() then
			self.autoauctionDialog:Hide()
		end
		self:QueryCompleted()
		self:AutoAuctionCompleted()
	end

	if not self.isAHshown then
		if ahColsed_doOnce then
			can_removeall, can_autoremove, checked_can_autoremove, checked_can_removeall = nil, nil, nil, nil
			querying, bidding, removing, autoremoving, removingall = nil, nil, nil, nil, nil
			t4.id, t4.info, t5.id, t5.info = {}, {}, {}, {}
			StaticPopup_Hide("AUTO_CANCELAUCTION")
			StaticPopup_Hide("CANCEL_ALLAUCTION")
			self:AutoAuctionCompleted()
			autoauction = {Inscription=0,Elemental=0,Cloth=0,Leather=0,Mining=0,Herb=0,Enchanting=0,Gem=0,Medicine=0,Quest=0,All=0,}
			t3 = {[0] = {}, [1] = {}, [2] = {}, [3] = {}, [4] = {}}
			ahColsed_doOnce = nil
			return
		else
			return
		end
	end

	if not ( "list" == AuctionFrame.type and AuctionFrameBrowse:IsVisible() ) then
		if ahBrowseClosed_doOnce then
			querying, bidding = nil, nil
			t4.id, t4.info = {}, {}
			if self.query_auctionitemsFrame then
				self.query_auctionitemsFrame:Hide()
				self.query_auctionitemsFrame.bar:Hide()
			end
			if self.query_completedtextFrame then
				self.query_completedtextFrame:Hide()
			end
			if dumplist_doOnce then dumplist_doOnce = nil end
			ahBrowseClosed_doOnce = nil
		end
	end

	if not (AuctionFrameAuctions:IsVisible() and AuctionFrame:IsVisible()) then
		if ahAuctionClosed_doOnce then
			can_removeall, can_autoremove, checked_can_autoremove, checked_can_removeall = nil, nil, nil, nil
			removing, autoremoving, removingall = nil, nil, nil
			t5.id, t5.info = {}, {}
			StaticPopup_Hide("AUTO_CANCELAUCTION")
			StaticPopup_Hide("CANCEL_ALLAUCTION")
			StaticPopup_Hide("AUTO_AUCTIONALL")
			self.autoauctionDialog:Hide()
			self:AutoAuctionCompleted()
			autoauction = {Inscription=0,Elemental=0,Cloth=0,Leather=0,Mining=0,Herb=0,Enchanting=0,Gem=0,Medicine=0,Quest=0,All=0,}
			t3 = {[0] = {}, [1] = {}, [2] = {}, [3] = {}, [4] = {}}
			if dumpowned_doOnce then dumpowned_doOnce = nil end
			ahAuctionClosed_doOnce = nil
		end
	end

	if "list" == AuctionFrame.type and AuctionFrameBrowse:IsVisible() then
		ahBrowseClosed_doOnce = 1

		if not dumplist_doOnce then
			dumplist_doOnce = 1
			self:DumpItemList()
		end

		if rules.scroll then
			self:UpdateQueryItems_and_AutoAuctionFrameSpark(elapsed)
		else
			self:UpdateQueryItems_and_AutoAuctionFrameStatusBar(elapsed)
		end

		if self.query_auctionitemsFrame:IsVisible() then
			self.query_auctionitemsFrame:SetFrameLevel(getMaxLevel(browseFrames) + 1)
			self.query_auctionitemsFrame.bar:SetFrameLevel(self.query_auctionitemsFrame:GetFrameLevel() + 1)
		end

		if self.query_completedtextFrame:IsVisible() then
			self.query_completedtextFrame:SetFrameLevel(max(AuctionFrame:GetFrameLevel(), AuctionFrameBrowse:GetFrameLevel()) + 1)
		end

		AHHelper:UpdateQueryItemsFrame(elapsed)

		if GetCVarBool("auctionDisplayOnCharacter") then
			SetCVar("auctionDisplayOnCharacter", false)
		end

		if GetAuctionItemInfo("list", 1) then
			self:UpdateBrowseButtons()
			local name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner
			local buttonName, buyoutFrame, moneyFrame, nameText, levelText, ownerText, buyoutMoney
			local offset = FauxScrollFrame_GetOffset(BrowseScrollFrame)
			local checkButton = ShowOnPlayerCheckButton:GetChecked()

			for i = 1, NUM_BROWSE_TO_DISPLAY do
				name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner =  GetAuctionItemInfo("list", offset + i)
				if name then
					nameText = _G["BrowseButton"..i.."Name"]
					if nameText then
						if strlen(name) > 40 then
							nameText:SetText(string.sub(name, 0, 36) .. "...")
						end
						if bidAmount > 0 then
							nameText:SetText(name .. " |cffffff00 ("..BIDDEN_TEXT..")|r")
						end
						if offset + i == GetSelectedAuctionItem("list") then
							if bidAmount > 0 then
								nameText:SetText("|cffffff00" .. name .. "  (" .. BIDDEN_TEXT .. ")|r")
							else
								nameText:SetText("|cffffff00" .. name .. "|r")
							end
						end
					end
	
					levelText = _G["BrowseButton"..i.."Level"]
					if offset + i == GetSelectedAuctionItem("list") then
						levelText:SetText("|cffffff00" .. level .. "|r")
					end
	
					timeText = _G["BrowseButton"..i.."ClosingTimeText"]
					if offset + i == GetSelectedAuctionItem("list") then
						timeText:SetText("|cffffff00" .. AuctionFrame_GetTimeLeftText(GetAuctionItemTimeLeft("list", offset + i)) .. "|r")
					end
	
					if owner then
						ownerText = _G["BrowseButton"..i.."HighBidder"]
						if offset + i == GetSelectedAuctionItem("list") then
							ownerText:SetText("|cffffff00" .. owner .. "|r")
						end
					end
	
					moneyFrame = _G["BrowseButton"..i.."MoneyFrame"]
					buttonName = "BrowseButton"..i
					buyoutFrame = _G[buttonName.."BuyoutFrame"]
	
					if checkButton and count > 1 then
						if buyoutFrame then
							buyoutMoney = _G[buyoutFrame:GetName().."Money"]
							MoneyFrame_Update(buyoutMoney, ceil(buyoutPrice/count))
						end
						if moneyFrame then
							if bidAmount > 0 then
								MoneyFrame_Update(moneyFrame:GetName(), ceil(bidAmount/count))
							else
								MoneyFrame_Update(moneyFrame:GetName(), ceil(minBid/count))
							end
						end
					else
						if buyoutFrame then
							buyoutMoney = _G[buyoutFrame:GetName().."Money"]
							MoneyFrame_Update(buyoutMoney, buyoutPrice)
						end
						if moneyFrame then
							if bidAmount > 0 then
								MoneyFrame_Update(moneyFrame:GetName(), bidAmount)
							else
								MoneyFrame_Update(moneyFrame:GetName(), minBid)
							end
						end
					end
				end
			end
			--self:DumpItemList()
		end
	elseif AuctionFrame:IsVisible() and AuctionFrameAuctions:IsVisible() then
		if 1 == self.spliting then
			local item, _, locked = GetContainerItemInfo(self.nextslot[1], self.nextslot[2])
			if item and not locked then
				self.spliting = nil
				DoAuction(self.nextslot[1], self.nextslot[2])
			end
		end
		ahAuctionClosed_doOnce = 1

		if not dumpowned_doOnce then
			dumpowned_doOnce = 1
			self:DumpOwnedList()
		end

		if rules.scroll then
			self:UpdateQueryItems_and_AutoAuctionFrameSpark(elapsed)
		else
			self:UpdateQueryItems_and_AutoAuctionFrameStatusBar(elapsed)
		end

		button3:SetText(CLEARMEMORY_TEXT .. ": " .. maxn(t1)/3)

		if self.autoauctionFrame:IsVisible() then
			self.autoauctionFrame:SetFrameLevel(getMaxLevel(auctionsFrames) + 1)
			self.autoauctionFrame.bar:SetFrameLevel(self.autoauctionFrame:GetFrameLevel() + 1)
		end

		local name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner, saleStatus
		local buttonName, buyoutFrame, moneyFrame, nameText, levelText, ownerText, buyoutMoney
		local offset = FauxScrollFrame_GetOffset(AuctionsScrollFrame)

		if not auto_auctioning then
			self:AutoAuctionCompleted()
		end
		self:UpdateAuctionsCreatedButtons()

		if GetAuctionItemInfo("owner", 1) then
			self:UpdateAuctionsButtons()
		end

		for i = 1, NUM_AUCTIONS_TO_DISPLAY do
			name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner, saleStatus =  GetAuctionItemInfo("owner", offset + i)
			if name then
				nameText = _G["AuctionsButton"..i.."Name"]
				if nameText then
					if strlen(name) > 40 then
						nameText:SetText(string.sub(name, 0, 36) .. "...")
					end
					local removeit = nil
					if ( 0 == saleStatus ) and ( 0 == bidAmount ) then
						if t1[name] and t1[name][texture] and ( buyoutPrice > 0 ) then
							if ( ceil(buyoutPrice/count) > t1[name][texture].buyout ) then
								nameText:SetText("|cffffff00("..REMOVE_TEXT..")|r " .. name)
								removeit = true
							elseif ( ceil(buyoutPrice/count) == t1[name][texture].buyout ) then
								if ( bidAmount > 0 ) then
									minBid = bidAmount
								end
								if ( ceil(minBid/count) > t1[name][texture].bid ) then
									nameText:SetText("|cffffff00("..REMOVE_TEXT..")|r " .. name)
									removeit = true
								end
							end
						elseif t1[name] and t1[name][texture] and ( 0 == buyoutPrice ) then
							if ( bidAmount > 0 ) then
								minBid = bidAmount
							end
							if ( ceil(minBid/count) > t1[name][texture].bid ) then
								nameText:SetText("|cffffff00("..REMOVE_TEXT..")|r " .. name)
								removeit = true
							end
						end
					elseif ( 0 == saleStatus ) and ( bidAmount > 0 ) then
						nameText:SetText(name .. " |cffffff00 ("..BIDDEN_TEXT..")|r")
					end
					if offset + i == GetSelectedAuctionItem("owner") then
						if removeit then
							nameText:SetText("|cffffff00("..REMOVE_TEXT..") " .. name .."|r ")
						else
							if ( 0 == saleStatus ) then
								if ( 0 == saleStatus ) and ( bidAmount > 0 ) then
									nameText:SetText("|cffffff00" .. name .. "  (".. BIDDEN_TEXT .. ")|r")
								else
									nameText:SetText("|cffffff00" .. name .. "|r")
								end
							else
								nameText:SetText("|cffffff00" .. format(AUCTION_ITEM_SOLD, name) .. "|r")
							end
						end
					end
				end

				timeText = _G["AuctionsButton"..i.."ClosingTimeText"]
				if ( 0 == saleStatus ) then
					if timeText then
						if offset + i == GetSelectedAuctionItem("owner") then
							timeText:SetText("|cffffff00" .. AuctionFrame_GetTimeLeftText(GetAuctionItemTimeLeft("owner", offset + i)) .. "|r")
						end
					end
				else
					if timeText then
						if offset + i == GetSelectedAuctionItem("owner") then
							timeText:SetText("|cffffff00" .. format(AUCTION_ITEM_TIME_UNTIL_DELIVERY, SecondsToTime(GetAuctionItemTimeLeft("owner", offset + i))) .. "|r")
						end
					end
				end

				ownerText = _G["AuctionsButton"..i.."HighBidder"]
				if highBidder and ownerText then
					if offset + i == GetSelectedAuctionItem("owner") then
						ownerText:SetText("|cffffff00" .. highBidder .. "|r")
					end
				end
			end
		end
	end
end

function AHHelper:AutoRemove()
	t5.id, t5.info = {}, {}
	autoremoving = 1
	local name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner, saleStatus
	if AuctionFrame:IsVisible() and AuctionFrameAuctions:IsVisible() then
		local v = GetNumAuctionItems("owner")
		if v > 0 then
			for i = v, 1, -1 do
				name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner, saleStatus = GetAuctionItemInfo("owner", i)
				if name then
					if (0 == bidAmount) and (0 == saleStatus) then
						if t1[name] and t1[name][texture] and ( buyoutPrice > 0 ) then
							if ( ceil(buyoutPrice/count) > t1[name][texture].buyout ) then
								CancelAuction(i)
							elseif ( ceil(buyoutPrice/count) == t1[name][texture].buyout ) and ( ceil(minBid/count) > t1[name][texture].bid ) then
								CancelAuction(i)
							end
						elseif ( name == t1.name[j] ) and ( texture == t1.texture[j] ) and ( buyoutPrice == 0 ) then
							if ( bidAmount > 0 ) then
								minBid = bidAmount
							end
							if ( ceil(minBid/count) > t1[name][texture].bid ) then
								CancelAuction(i)
							end
						end
					end
				end
			end
		end
	end
end

function AHHelper:RemoveAll()
	local name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner, saleStatus
	if AuctionFrame:IsVisible() and AuctionFrameAuctions:IsVisible() then
		local v = GetNumAuctionItems("owner")
		if v > 0 then
			for i = v, 1, -1 do
				name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner, saleStatus = GetAuctionItemInfo("owner", i)
				if name then
					if (0 == bidAmount) and (0 == saleStatus) then
						CancelAuction(i)
					end
				end
			end
		end
	end
end

local enable_UIErrorsFrame
local enable_SFX
function AHHelper:SearchAutoAuctionItems()
	auto_auctioning = 1
	ClearCursor()
	ClickAuctionSellItemButton()
	ClearCursor()
	SetSelectedAuctionItem("owner", 0)
	AuctionsScrollFrame:SetAlpha(0)
	if AuctionsSearchCountText then
		AuctionsSearchCountText:SetAlpha(0)
	end
	for i = 1, NUM_AUCTIONS_TO_DISPLAY do
		_G["AuctionsButton"..i]:SetAlpha(0)
	end
	StartPriceGold:ClearFocus()
	StartPriceSilver:ClearFocus()
	StartPriceCopper:ClearFocus()
	BuyoutPriceGold:ClearFocus()
	BuyoutPriceSilver:ClearFocus()
	BuyoutPriceCopper:ClearFocus()
	self.autoauctionFrame:Show()
	if UIErrorsFrame:IsEventRegistered("UI_ERROR_MESSAGE") then
		enable_UIErrorsFrame = 1
		UIErrorsFrame:UnregisterEvent("UI_ERROR_MESSAGE")
	else
		enable_UIErrorsFrame = nil
	end
	if "1" == GetCVar("Sound_EnableSFX") then
		enable_SFX = 1
		SetCVar("Sound_EnableSFX", "0")
	else
		enable_SFX = nil
	end
	if 1 == autoauction.Inscription then
		for i = 0, 4 do
			if GetContainerNumSlots(i) > 0 then
				for j = 1, GetContainerNumSlots(i) do
					local id = GetContainerItemID(i, j)
					if ( "number" == type(id) and 16 == GetItemFamily(id) ) then
						local name, _, _, _, _, _, _, _, _, texture = GetItemInfo(id)
						if t1[name] and t1[name][texture] then
							PickupContainerItem(i, j)
							ClickAuctionSellItemButton()
							if GetAuctionSellItemInfo() then
								ClickAuctionSellItemButton()
								_, t3[i][j] = GetContainerItemInfo(i, j)
							end
							ClearCursor()
						end
					end
				end
			end
		end
	elseif 1 == autoauction.Elemental then
		for i = 0, 4 do
			if GetContainerNumSlots(i) > 0 then
				for j = 1, GetContainerNumSlots(i) do
					local id = GetContainerItemID(i, j)
					if ( "number" == type(id) and 200 == GetItemFamily(id) ) then
						local name, _, _, _, _, _, _, _, _, texture = GetItemInfo(id)
						if t1[name] and t1[name][texture] then
							PickupContainerItem(i, j)
							ClickAuctionSellItemButton()
							if GetAuctionSellItemInfo() then
								ClickAuctionSellItemButton()
								_, t3[i][j] = GetContainerItemInfo(i, j)
							end
							ClearCursor()
						end
					end
				end
			end
		end
	elseif 1 == autoauction.Cloth then
		for i = 0, 4 do
			if GetContainerNumSlots(i) > 0 then
				for j = 1, GetContainerNumSlots(i) do
					local id = GetContainerItemID(i, j)
					if ( "number" == type(id) ) then
						if select(7, GetItemInfo(id)) == select(2,GetAuctionItemSubClasses(6)) then
							local name, _, _, _, _, _, _, _, _, texture = GetItemInfo(id)
							if t1[name] and t1[name][texture] then
								PickupContainerItem(i, j)
								ClickAuctionSellItemButton()
								if GetAuctionSellItemInfo() then
									ClickAuctionSellItemButton()
									_, t3[i][j] = GetContainerItemInfo(i, j)
								end
								ClearCursor()
							end
						end
					end
				end
			end
		end
	elseif 1 == autoauction.Leather then
		for i = 0, 4 do
			if GetContainerNumSlots(i) > 0 then
				for j = 1, GetContainerNumSlots(i) do
					local id = GetContainerItemID(i, j)
					if ( "number" == type(id) and 8 == GetItemFamily(id) ) then
						local name, _, _, _, _, _, _, _, _, texture = GetItemInfo(id)
						if t1[name] and t1[name][texture] then
							PickupContainerItem(i, j)
							ClickAuctionSellItemButton()
							if GetAuctionSellItemInfo() then
								ClickAuctionSellItemButton()
								_, t3[i][j] = GetContainerItemInfo(i, j)
							end
							ClearCursor()
						end
					end
				end
			end
		end
	elseif 1 == autoauction.Mining then
		for i = 0, 4 do
			if GetContainerNumSlots(i) > 0 then
				for j = 1, GetContainerNumSlots(i) do
					local id = GetContainerItemID(i, j)
					if ( "number" == type(id) and 1024 == GetItemFamily(id) ) then
						local name, _, _, _, _, _, _, _, _, texture = GetItemInfo(id)
						if t1[name] and t1[name][texture] then
							PickupContainerItem(i, j)
							ClickAuctionSellItemButton()
							if GetAuctionSellItemInfo() then
								ClickAuctionSellItemButton()
								_, t3[i][j] = GetContainerItemInfo(i, j)
							end
							ClearCursor()
						end
					end
				end
			end
		end
	elseif 1 == autoauction.Herb then
		for i = 0, 4 do
			if GetContainerNumSlots(i) > 0 then
				for j = 1, GetContainerNumSlots(i) do
					local id = GetContainerItemID(i, j)
					if ( "number" == type(id) and (32 == GetItemFamily(id) or 168 == GetItemFamily(id)) ) then
						local name, _, _, _, _, _, _, _, _, texture = GetItemInfo(id)
						if t1[name] and t1[name][texture] then
							PickupContainerItem(i, j)
							ClickAuctionSellItemButton()
							if GetAuctionSellItemInfo() then
								ClickAuctionSellItemButton()
								_, t3[i][j] = GetContainerItemInfo(i, j)
							end
							ClearCursor()
						end
					end
				end
			end
		end
	elseif 1 == autoauction.Enchanting then
		for i = 0, 4 do
			if GetContainerNumSlots(i) > 0 then
				for j = 1, GetContainerNumSlots(i) do
					local id = GetContainerItemID(i, j)
					if ( "number" == type(id) and 64 == GetItemFamily(id) ) then
						local name, _, _, _, _, _, _, _, _, texture = GetItemInfo(id)
						if t1[name] and t1[name][texture] then
							PickupContainerItem(i, j)
							ClickAuctionSellItemButton()
							if GetAuctionSellItemInfo() then
								ClickAuctionSellItemButton()
								_, t3[i][j] = GetContainerItemInfo(i, j)
							end
							ClearCursor()
						end
					end
				end
			end
		end
	elseif 1 == autoauction.Medicine then
		for i = 0, 4 do
			if GetContainerNumSlots(i) > 0 then
				for j = 1, GetContainerNumSlots(i) do
					local id = GetContainerItemID(i, j)
					if ( "number" == type(id) ) then
						if select(7, GetItemInfo(id)) == select(2, GetAuctionItemSubClasses(4))
							or select(7, GetItemInfo(id)) == select(3, GetAuctionItemSubClasses(4))
							or select(7, GetItemInfo(id)) == select(4, GetAuctionItemSubClasses(4))
						then
							local name, _, _, _, _, _, _, _, _, texture = GetItemInfo(id)
							if t1[name] and t1[name][texture] then
								PickupContainerItem(i, j)
								ClickAuctionSellItemButton()
								if GetAuctionSellItemInfo() then
									ClickAuctionSellItemButton()
									_, t3[i][j] = GetContainerItemInfo(i, j)
								end
								ClearCursor()
							end
						end
					end
				end
			end
		end
	elseif 1 == autoauction.Gem then
		for i = 0, 4 do
			if GetContainerNumSlots(i) > 0 then
				for j = 1, GetContainerNumSlots(i) do
					local id = GetContainerItemID(i, j)
					if ( "number" == type(id) and 512 == GetItemFamily(id) ) then
						local name, _, _, _, _, _, _, _, _, texture = GetItemInfo(id)
						if t1[name] and t1[name][texture] then
							PickupContainerItem(i, j)
							ClickAuctionSellItemButton()
							if GetAuctionSellItemInfo() then
								ClickAuctionSellItemButton()
								_, t3[i][j] = GetContainerItemInfo(i, j)
							end
							ClearCursor()
						end
					end
				end
			end
		end
	elseif 1 == autoauction.Quest then
		for i = 0, 4 do
			if GetContainerNumSlots(i) > 0 then
				for j = 1, GetContainerNumSlots(i) do
					local id = GetContainerItemID(i, j)
					if ( "number" == type(id) ) then
						if select(7, GetItemInfo(id)) == select(12, GetAuctionItemClasses()) then
							local name, _, _, _, _, _, _, _, _, texture = GetItemInfo(id)
							if t1[name] and t1[name][texture] then
								PickupContainerItem(i, j)
								ClickAuctionSellItemButton()
								if GetAuctionSellItemInfo() then
									ClickAuctionSellItemButton()
									_, t3[i][j] = GetContainerItemInfo(i, j)
								end
								ClearCursor()
							end
						end
					end
				end
			end
		end
	elseif 1 == autoauction.All then
		for i = 0, 4 do
			if GetContainerNumSlots(i) > 0 then
				for j = 1, GetContainerNumSlots(i) do
					local id = GetContainerItemID(i, j)
					if ( "number" == type(id) ) then
						local name, _, _, _, _, _, _, _, _, texture = GetItemInfo(id)
						if t1[name] and t1[name][texture] then
							PickupContainerItem(i, j)
							ClickAuctionSellItemButton()
							if GetAuctionSellItemInfo() then
								ClickAuctionSellItemButton()
								_, t3[i][j] = GetContainerItemInfo(i, j)
							end
							ClearCursor()
						end
					end
				end
			end
		end
	end
	if enable_SFX then
		SetCVar("Sound_EnableSFX", "1")
	end
	if enable_UIErrorsFrame then
		UIErrorsFrame:RegisterEvent("UI_ERROR_MESSAGE")
	end
end

function AHHelper:AutoAuction()
	if not auto_auctioning then return end

	if computeOnce then
		auction_alltimes, auction_times = 0, 0
		auction_alltimes = GetAuctionAlltimes()
		--print(auction_alltimes)
		computeOnce = nil
	end
	local value = 0
	for i = 0, 4 do
		value = maxn(t3[i]) + value
	end
	if 0 == value then
		self:AutoAuctionCompleted()
	else
		for i = 0, 4 do
			if maxn(t3[i]) > 0 then
				for j = 1, GetContainerNumSlots(i) do
					if "number"==type(t3[i][j]) then
						if self.split > 0 and t3[i][j] > self.split then
							local bag, slot = GetFitSlot(GetContainerItemID(i, j))
							if bag and slot then
								self.spliting = 1
								SplitContainerItem(i, j, self.split)
								DoAuction(bag, slot)
								t3[i][j] = t3[i][j] - self.split
								return
							else
								local least, least_slot, found = 0, {}
								for bag = 0, 4 do
									if maxn(t3[bag]) > 0 then
										for slot = 1, GetContainerNumSlots(bag) do
											if "number"==type(t3[bag][slot]) then
												least = least==0 and t3[bag][slot] or least
												least_slot = least_slot=={} and {bag, slot} or least_slot
												if least > t3[bag][slot] then
													least = t3[bag][slot]
													least_slot = {bag, slot}
												end
												if least <= self.split then found = true break end
											end
										end
									end
									if found then break end
								end
								if maxn(least_slot) == 2 then
									DoAuction(least_slot[1], least_slot[2])
									t3[least_slot[1]][least_slot[2]] = nil
									return
								end
							end
						end
						DoAuction(i, j)
						t3[i][j] = nil
						return
					end
				end
			end
		end
	end
end

function AHHelper:AutoAuctionCompleted()
	auto_auctioning = nil
	self.spliting = nil
	self.nextslot = {}
	if AuctionFrame then
		AuctionsScrollFrame:SetAlpha(ORG_ALPHA)
		for i = 1, NUM_AUCTIONS_TO_DISPLAY do
			_G["AuctionsButton"..i]:SetAlpha(ORG_ALPHA)
		end
		AuctionsCloseButton:Enable()
		if AuctionsSearchCountText then
			AuctionsSearchCountText:SetAlpha(ORG_ALPHA)
		end
	end
	computeOnce = 1
	auction_alltimes, auction_times = 0, 0
	if self.autoauctionFrame then
		self.autoauctionFrame:Hide()
		self.autoauctionFrame.bar:Hide()
		self.autoauctionFrame.text:Hide()
	end
end

function AHHelper:QueryCompleted()
	querying = nil
	barWidth, lastbarWidth, barLeftTime = 0, 0, 0
	self.timer = 0
	noQuerying_doOnce = nil
	button0:Enable()
	if AuctionFrame then
		BrowseSearchButton:SetScript("OnUpdate", function(BrowseSearchButton, elapsed)
			BrowseSearchButton_OnUpdate(BrowseSearchButton, elapsed)
		end)
		BrowseResetButton:SetScript("OnUpdate", function(BrowseResetButton, elapsed)
			BrowseResetButton_OnUpdate(BrowseResetButton, elapsed)
		end)
		BrowseName:SetScript("OnEnterPressed", function()
			self.query_completedtextFrame:Hide()
			BrowseSearchCountText:SetAlpha(ORG_ALPHA)
			BrowseSearchDotsText:SetAlpha(ORG_ALPHA)
			BrowseNoResultsText:SetAlpha(ORG_ALPHA)
			AuctionFrameBrowse_Search()
			BrowseName:ClearFocus()
		end)
		BrowseCloseButton:Enable()
		BrowseScrollFrame:SetAlpha(ORG_ALPHA)
		for i = 1, NUM_BROWSE_TO_DISPLAY do
			_G["BrowseButton"..i]:SetAlpha(ORG_ALPHA)
		end
	end
	if self.query_auctionitemsFrame then
		self.query_auctionitemsFrame:Hide()
		self.query_auctionitemsFrame.bar:Hide()
		self.query_auctionitemsFrame.text:Hide()
	end
end

function AHHelper:UpdateAuctionsCreatedButtons()
	if auto_auctioning then
		button1:Disable()
		button2:Disable()
		button3:Disable()
		button4:Disable()
		AuctionsCloseButton:Disable()
	else
		button2:Enable()
		button3:Enable()
	end

	local name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner, saleStatus
	if (not autoremoving) and (not removingall) and (not removing) and (not auto_auctioning) then
		local v = GetNumAuctionItems("owner")
		if v > 0 then
			for i = v, 1, -1 do
				name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner, saleStatus =  GetAuctionItemInfo("owner", i)
				if (name) and (not can_removeall) then
					if ( not checked_can_removeall ) then
						if (0 == bidAmount) and (0 == saleStatus) then
							checked_can_removeall = true
							can_removeall = true
						end
					end
				end
				if (name) and (not can_autoremove) then
					if (0 == bidAmount) and (0 == saleStatus) then
						if ( not checked_can_autoremove ) then
							if t1[name] and t1[name][texture] and ( buyoutPrice > 0 ) then
								if ( ceil(buyoutPrice/count) > t1[name][texture].buyout ) then
									can_autoremove = true
									checked_can_autoremove = true
								elseif ( ceil(buyoutPrice/count) == t1[name][texture].buyout ) and ( ceil(minBid/count) > t1[name][texture].bid ) then
									can_autoremove = true
									checked_can_autoremove = true
								end
							elseif t1[name] and t1[name][texture] and ( 0 == buyoutPrice ) then
								if ( bidAmount > 0 ) then
									minBid = bidAmount
								end
								if ( ceil(minBid/count) > t1[name][texture].bid ) then
									can_autoremove = true
									checked_can_autoremove = true
								end
							end
						end
					end
				end
			end
		end
		if (can_autoremove) and maxn(t1)>0 then
			button1:Enable()
		else
			button1:Disable()
		end
		if (can_removeall) and maxn(t2)>0 then
			button4:Enable()
		else
			button4:Disable()
		end
	else
		button1:Disable()
		button4:Disable()
	end
	if (maxn(t1) > 0) and (not auto_auctioning) then
		button3:Enable()
	else
		button3:Disable()
	end

	if autoremoving then
		local can_remove = nil
		local v = GetNumAuctionItems("owner")
		if v > 0 then
			for i = v, 1, -1 do
				name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner, saleStatus =  GetAuctionItemInfo("owner", i)
				if name then
					if (0 == bidAmount) and (0 == saleStatus) then
						if t1[name] and t1[name][texture] and ( buyoutPrice > 0 ) then
							if ( ceil(buyoutPrice/count) > t1[name][texture].buyout ) then
								can_remove = true
								break
							elseif ( ceil(buyoutPrice/count) == t1[name][texture].buyout ) and ( ceil(minBid/count) > t1[name][texture].bid ) then
								can_remove = true
								break
							end
						elseif t1[name] and t1[name][texture] and ( 0 == buyoutPrice ) then
							if ( bidAmount > 0 ) then
								minBid = bidAmount
							end
							if ( ceil(minBid/count) > t1[name][texture].bid ) then
								can_remove = true
								break
							end
						end
					end
				end
			end
		end
		if not can_remove then
			can_autoremove = nil
			autoremoving = nil
		end
	elseif removingall then
		local can_remove = nil
		if AuctionFrame:IsVisible() and AuctionFrameAuctions:IsVisible() then
			local v = GetNumAuctionItems("owner")
			if v > 0 then
				for i = v, 1, -1 do
					name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner, saleStatus = GetAuctionItemInfo("owner", i)
					if name then
						if (0 == bidAmount) and (0 == saleStatus) then
							can_remove = true
							break
						end
					end
				end
			end
		end
		if not can_remove then
			can_removeall = nil
			removingall = nil
		end
	end
end

function AHHelper:UpdateBidButton()
	local canBuyout, canBid = 1, 1
	local allPrice = 0
	if #t4.id > 1 then
		for i = 1, #t4.id do
			local oneprice = t4.info[i][9]
			if 0 == oneprice or PLAYER_NAME == t4.info[i][12] then
				allPrice = 0
				break
			end
			allPrice = allPrice + oneprice
		end
	elseif 1 == #t4.id then
		if PLAYER_NAME == t4.info[1][12] then
			allPrice = 0
		else
			allPrice = t4.info[1][9]
		end
	end

	if bidding then
		BrowseBuyoutButton:Disable()
	else
		if #t4.id > 0 then
			if GetMoney() < allPrice or 0 == allPrice then
				canBuyout = nil
			end
			if canBuyout then
				BrowseBuyoutButton:Enable()
			else
				BrowseBuyoutButton:Disable()
			end
		else
			BrowseBuyoutButton:Disable()
		end
	end

	local allBid = 0
	if #t4.id > 1 then
		for i = 1, #t4.id do
			if t4.info[i][11] or PLAYER_NAME == t4.info[i][12] then
				allBid = 0
				break
			else
				local onebid
				if 0 == t4.info[i][10] then
					onebid = t4.info[i][7]
				else
					onebid = t4.info[i][10] + t4.info[i][8]
				end
				allBid = allBid + onebid
			end
		end
	elseif 1 == #t4.id then
		if t4.info[1][11] or PLAYER_NAME == t4.info[1][12] then
			allBid = 0
		else
			if 0 == t4.info[1][10] then
				allBid = t4.info[1][7]
			else
				allBid = t4.info[1][10] + t4.info[1][8]
			end
		end
	end

	if bidding then
		BrowseBidButton:Disable()
	else
		if #t4.id > 0 then
			if GetMoney() < allBid or 0 == allBid then
				canBid = nil
			end
			if canBid then
				BrowseBidButton:Enable()
			else
				BrowseBidButton:Disable()
			end			
		else
			BrowseBidButton:Disable()
		end
	end
end

function AHHelper:UpdateCancelAuctionButton()
	local canCancelAuction = 1
	local allCancelPrice = 0
	if #t5.id > 0 then
		for i = 1, #t5.id do
			local oneCancelPrice = t5.info[i][10] * .05
			allCancelPrice = allCancelPrice + oneCancelPrice
		end
	end

	if removing or autoremoving or removingall then
		AuctionsCancelAuctionButton:Disable()
	else
		if #t5.id > 0 then
			if GetMoney() < allCancelPrice then
				canCancelAuction = nil
			end
			for i = 1, #t5.id do
				if 1 == t5.info[i][13] then
					canCancelAuction = nil
				end
			end
			if canCancelAuction then
				AuctionsCancelAuctionButton:Enable()
			else
				AuctionsCancelAuctionButton:Disable()
			end
		else
			AuctionsCancelAuctionButton:Disable()
		end
	end
end

function AHHelper:UpdateAuctionsButtons()
	local offset = FauxScrollFrame_GetOffset(AuctionsScrollFrame)
	local button
	local cansee = {}
	local changed = {}
	local id = GetSelectedAuctionItem("owner")

	if #t5.id > 0 then
		for i = 1, #t5.id do
			for j = 1, NUM_AUCTIONS_TO_DISPLAY do
				local a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13 = GetAuctionItemInfo("owner", offset + j)
				if _compare(t5.info[i], a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) and offset + j == t5.id[i] then
					cansee[i] = 1
					break
				else
					cansee[i] = nil
				end
			end
		end

		for i = #t5.id, 1, -1 do
			if not cansee[i] then
				tremove(t5.id, i)
				tremove(t5.info, i)
			end
		end
		self.UpdateCancelAuctionButton()

		if #t5.id > 0 then
			for i = 1, NUM_AUCTIONS_TO_DISPLAY do
				button = _G["AuctionsButton"..i]
				if button then
					for j = 1, #t5.id do
						local a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13 = GetAuctionItemInfo("owner", offset + i)
						if _compare(t5.info[j], a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) and offset + i == t5.id[j] then
							button:LockHighlight()
							break
						end
						button:UnlockHighlight()
					end
				end
			end
			for i = 1, #t5.id do
				local a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13 = GetAuctionItemInfo("owner", t5.id[i])
				if not _compare(t5.info[i] ,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) then
					changed[i] = 1
				end
			end
			if #changed > 0 then
				for i = 1, #changed do
					tremove(t5.id, changed[i])
					tremove(t5.info, changed[i])
					changed[i] = nil
				end
				self.UpdateCancelAuctionButton()
			end

			for i = 1, NUM_AUCTIONS_TO_DISPLAY do
				if GetSelectedAuctionItem("owner") and offset + i == GetSelectedAuctionItem("owner") then
					return
				end
			end

			if #t5.id > 0 then
				SetSelectedAuctionItem("owner", t5.id[#t5.id])
				if ( id ~= GetSelectedAuctionItem("owner") ) and (not removing) and (not autoremoving) and (not removingall) and (not auto_auctioning) then
					AuctionFrameAuctions_Update()
					self:UpdateCancelAuctionButton()
				end
			else
				SetSelectedAuctionItem("owner", 0)
				AuctionFrameAuctions_Update()
				self:UpdateCancelAuctionButton()
			end
		end
	else
		removing = nil
		for i = 1, NUM_AUCTIONS_TO_DISPLAY do
			button = _G["AuctionsButton"..i]
			if button then
				if GetSelectedAuctionItem("owner") and offset + i == GetSelectedAuctionItem("owner") then
					local name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner, saleStatus = GetAuctionItemInfo("owner", offset + i)
					tinsert(t5.id, offset + i)
					tinsert(t5.info, {name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner, saleStatus})
					button:LockHighlight()
					self:UpdateCancelAuctionButton()
					AuctionFrameAuctions_Update()
					self:UpdateCancelAuctionButton()
					return
				end
			end
		end
		AuctionFrameAuctions_Update()
		self:UpdateCancelAuctionButton()
	end
end

local setzeroOnce
function AHHelper:UpdateBrowseButtons()
	local offset = FauxScrollFrame_GetOffset(BrowseScrollFrame)
	local button	
	local cansee = {}
	local changed = {}
	local id = GetSelectedAuctionItem("list")

	if #t4.id > 0 then
		setzeroOnce = 1

		for i = 1, #t4.id do
			for j = 1, NUM_BROWSE_TO_DISPLAY do
				button = _G["BrowseButton"..j]
				local a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12 = GetAuctionItemInfo("list", offset + j)
				if _compare(t4.info[i], a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12) and offset + j == t4.id[i] then
					cansee[i] = 1
					break
				else
					cansee[i] = nil
				end
			end
		end

		for i = #t4.id, 1, -1 do
			if not cansee[i] then
				tremove(t4.id, i)
				tremove(t4.info, i)
			end
		end
		self:UpdateBidButton()

		if #t4.id > 0 then
			for i = 1, NUM_BROWSE_TO_DISPLAY do
				button = _G["BrowseButton"..i]
				if button then
					for j = 1, #t4.id do
						local a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12 = GetAuctionItemInfo("list", offset + i)
						if _compare(t4.info[j], a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12) and offset + i == t4.id[j] then
							button:LockHighlight()
							break
						end
						button:UnlockHighlight()
					end
				end
				for i = 1, #t4.id do
					local a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12 = GetAuctionItemInfo("list", t4.id[i])
					if not _compare(t4.info[i], a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12) then
						changed[i] = 1
					end
				end
			end
			if #changed > 0 then
				for i = 1, #changed do
					tremove(t4.id, changed[i])
					tremove(t4.info, changed[i])
					changed[i] = nil
				end
				self.UpdateBidButton()
			end

			for i = 1, NUM_BROWSE_TO_DISPLAY do
				if GetSelectedAuctionItem("list") and offset + i == GetSelectedAuctionItem("list") then
					return
				end
			end
			if #t4.id > 0 then
				SetSelectedAuctionItem("list", t4.id[#t4.id])
				if id ~= GetSelectedAuctionItem("list") and not bidding then
					local lastprice
					if 0 == t4.info[#t4.id][10] then
						lastprice = t4.info[#t4.id][7]
					else
						lastprice = t4.info[#t4.id][10] + t4.info[#t4.id][8]
					end
					AuctionFrameBrowse_Update()
					self:UpdateBidButton()
				end
			else
				SetSelectedAuctionItem("list", 0)
				AuctionFrameBrowse_Update()
				self:UpdateBidButton()
			end
		end
	else
		bidding = nil
		if setzeroOnce and 0 ~= MoneyInputFrame_GetCopper(BrowseBidPrice) then
			setzeroOnce = nil
			MoneyInputFrame_SetCopper(BrowseBidPrice, 0)
		end
		for i = 1, NUM_BROWSE_TO_DISPLAY do
			button = _G["BrowseButton"..i]
			if button then
				if GetSelectedAuctionItem("list") and offset + i == GetSelectedAuctionItem("list") then
					local name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner = GetAuctionItemInfo("list", offset + i)
					tinsert(t4.id, offset + i)
					tinsert(t4.info, {name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner})
					button:LockHighlight()
					self:UpdateBidButton()
					AuctionFrameBrowse_Update()
					self:UpdateBidButton()
					return
				end
			end
		end
		AuctionFrameBrowse_Update()
		self:UpdateBidButton()
	end
end

function AHHelper:ClearMemory()
	if maxn(t1) > 0 then
		for k1, v1 in pairs(t1) do
			if "table"==type(v1) then
				for k2, v2 in pairs(v1) do
					if "table"==type(v2) then
						t1[k1][k2] = nil
					end
				end
				t1[k1] = nil
			end
		end
		t1 = {}
	end
	collectgarbage()
end